<?php
/*
+---------------------------------------------------------------+
|       e107 website system imagegallery plugin
|       e107_plugins/imagegallery/admin_batchadd.php
|
|        Mark Pustjens 2003
|       http://unkie.org
|       mark@unkie.org
| 
|       Released under the terms and conditions of the
|       GNU General Public License (http://gnu.org).    
+---------------------------------------------------------------+
*/  

require_once("../../class2.php");

@include("languages/imagegallery_".e_LANGUAGE.".php");
include("languages/imagegallery_English.php");

/* some handy functions */
require_once("functions.php");
require_once(e_HANDLER."form_handler.php");

/* we need some javascript */
$eplug_js = "imagegallery.js";

/* check authorisation */
list($category) = explode(".", e_QUERY);
$category = intval($category);
if ($category <= 0) $category = 1;

if(!is_authorized($category, "admin") && !getperms("P")){
  header('location:'.SITEURL.'index.php');
  exit;
}

/* get some vars */
$setup = $_POST['setup'];
$imagelist = $_POST['imagelist'];
$frm = new form;

/*
 * check the vars
 */
if (!isset($setup['category_id']) || $setup['category_id'] == "") $setup['category_id'] = $category;
if (!isset($setup['category_name']) || $setup['category_name'] == ""){
  $sql->db_Select("images_category", "category_name", "category_id=".$setup['category_id']);
  list($setup['category_name']) = $sql->db_Fetch();
}
if (!isset($setup['mode']) || $setup['mode'] == "") $setup['mode'] = "add";
if ($setup['mode'] == "new"){
  if (!isset($setup['new_category_name']) || $setup['new_category_name'] == "") $setup['new_category_name'] = "Subcategory";
  if (!isset($setup['category_description']) || $setup['category_description'] == "") $setup['category_description'] = IG_001;
}
if (!isset($setup['path'])){
  $setup['path'] = "upload/";
} else if (substr($setup['path'], -1) != "/"){
  $setup['path'] .= "/";
}

/*
 * add the images
 */
if (isset($_POST['add'])){
  $message = add_images($setup, $imagelist);
  $message .= $frm->form_open("post", "admin_browse.php?".$setup['category_id']);
  $message .= "<br /><div style='text-align: center;'>";
  $message .= $frm->form_button("submit", "back", "Back");
  $message .= "</div>";
  $message .= $frm->form_close();
}

/*
 * render the page
 */
$mytxt = render_page($setup, $imagelist);

/*
 * now display the page
 */
if (ADMIN) require_once(e_ADMIN.'auth.php'); else require_once(HEADERF);
if ($message){
  $ns->tablerender(IG_002, $message);
}
$ns->tablerender(IG_003, $mytxt);
if (ADMIN) require_once(e_ADMIN.'footer.php'); else require_once(FOOTERF);

/*******************************************************************/

/* render the page by putting the parts together
 */
function render_page($setup, $imagelist){
  global $frm;

  $text = $frm->form_open("post", e_SELF.'?'.$setup['category_id'], 'batchadd_images');
  $text .= render_setup($setup);
  $text .= "<br /><br />";
  $text .= render_images($setup['path'], $imagelist);
  $text .= $frm->form_close();

  return $text;
}

/* render the settings form for the batch add
 */
function render_setup($setup){
  global $sql, $setup, $frm;
  $tp = new textparse;
  
  foreach ($setup as $key => $value){
    $setup[$key] = $tp->formtpa($value);
  }
  
  $addselected = $setup['mode'] == "add" ? 1 : 0;

  /* get a list of paths available with images */
  $paths = get_paths();

  /* find out the category name */

  $category = $setup['category_id']." - ".$setup['category_name'];

  /* check if there is something wrong with the current settings */
  $error = check_settings($setup);

  /**/
  $text = $frm->form_hidden("setup[category_id]", $setup['category_id']);
  $text .= $frm->form_hidden("setup[category_name]", $setup['category_name']);
  $text .= '<table style="width:100%">
  	      <tr>
	        <td colspan="2" class="forumheader">'.IG_004.'<td>
	      </tr>
              <tr>
	        <td class="forumheader3" style="width: 40%;">
		  '.IG_005.'<br />
		  <span class="smalltext">'.IG_006.'</span>
		</td>
	        <td class="forumheader3">'.e_FILE.'imagegallery/';
  /* display the list of available paths with images
   */
  $text .= $frm->form_select_open("setup[path]");
  foreach ($paths as $path){
    $text .= $frm->form_option($path, ($path."/" == $setup['path'] ? 1 : 0), $path);
  }
  $text .= $frm->form_select_close();
  /**/
  $text .=     "</td>
	      </tr>";
  /* check if the selected path is writable
   */
  if ($error[0]) {
    $text .= '<tr><td colspan="2" class="forumheader2">'.sprintf(IG_007, e_FILE.'imagegallery/'.$setup['path']).'</td></tr>';
  }
  /**/
  $text .=   "<tr>
	        <td colspan='2' class='forumheader3'>";
  $text .= $frm->form_radio("setup[mode]", "add", $addselected);
  $text .=       IG_008.'<br />
  		  <span class="smalltext">'.sprintf(IG_009, $category).'</span>
  		</td>
	      </tr>';
  /* if the images are being added to an existing category,
   * check ik the categories folder is writable
   */
  if ($addselected && $error[1]) {
    $text .= '<tr><td colspan="2" class="forumheader2">'.sprintf(IG_007, e_FILE.'imagegallery/'.$category).'</td></tr>';
  }
  /**/
  $text .=   "<tr>
	        <td class='forumheader3'>";
  $text .= $frm->form_radio("setup[mode]", "new", !$addselected);
  $text .=       IG_010.'<br />
  		  <span class="smalltext">'.IG_011.'</spam>
	        </td>
	        <td class="forumheader3">'.IG_012.'<br />';
  $text .= $frm->form_text('setup[new_category_name]', 35, $tp->formtparev($setup['new_category_name'], 100));
  $text .= '<br />'.IG_013.'<br />';
  $text .= $frm->form_textarea("setup[category_description]", 50, 4, $tp->formtparev($setup['category_description']));
  $text .=   '</td>
	      </tr>';
  /* if a new subcategory should be made, check to
   * see if a folder for the new category can be made
   * and if the category name allready exists for
   * this category
   */
  if (!$addselected && $error[3]) {
    $text .= '<tr><td colspan="2" class="forumheader2">'.sprintf(IG_014, $setup['new_category_name']).'</td></tr>';
  }
  /**/
  if (!$addselected && $error[2]) {
    $text .= '<tr><td colspan="2" class="forumheader2">'.sprintf(IG_007, e_FILE.'imagegallery').'</td></tr>';
  }
  /**/
  if (!$addselected && $error[4]) {
    $text .= '<tr><td colspan="2" class="forumheader2">'.IG_015.'</td></tr>';
  }
  /**/
  $text .=   '<tr><td colspan="2" class="forumheader">'.IG_016.'</td></tr>
              <tr>
	        <td colspan="2" style="text-align: center;" class="forumheader3">';
  $text .= $frm->form_button("submit", "refresh", IG_017);
  if (!($addselected && $error[1]) && !(!$addselected && ($error[2] || $error[3] || $error[4]))){
    $text .= $frm->form_button("submit", "add", IG_018);
  }
  $text .= $frm->form_button("button", "back", IG_019, "onClick=\"javascript: document.location='admin_browse.php?".$setup['category_id']."'\"");
  $text .=   '</td>
	      </tr>
	    </table>';

  return $text;
}

/* for each image found in $path, display a part of the form
 */
function render_images($path, $imagelist){
  /* get the list of images */
  $images = get_images($path);
  $frm = new form;

  $text = '<table width="100%">
  	     <tr><td colspan="3" class="forumheader">'.IG_020.'</td></tr>
	     <tr><td colspan="3" class="forumheader3" style="text-align: center;">';
  $text .= $frm->form_button("button", "check", IG_021, "onClick=\"javascript: batchadd_checkall('check')\"");
  $text .= $frm->form_button("button", "uncheck", IG_022, "onClick=\"javascript: batchadd_checkall('uncheck')\"");
  $text .= $frm->form_button("button", "invert", IG_023, "onClick=\"javascript: batchadd_checkall('invert')\"");
  $text .= "</td></tr>";
  $text .= render_header();

  /* render the list of images, or an message if none were found */
  if (count($images)){
    foreach($images as $image){
      if (!isset($imagelist[$image])) {
        $imagelist[$image]['image'] = $image;
        $imagelist[$image]['path'] = $path;
        $imagelist[$image]['name'] = $image;
        $imagelist[$image]['description'] = $image;
        $imagelist[$image]['filesize'] = filesize(e_FILE."imagegallery/".$imagelist[$image]['path'].$imagelist[$image]['image']);
        $imagelist[$image]['filedetails'] = parseimagedetails(e_FILE."imagegallery/".$imagelist[$image]['path'].$imagelist[$image]['image']);
      }
      $text .= render_image($imagelist[$image]);
    }
  } else {
    $text .= '<tr><td colspan="3" class="forumheader3">'.sprintf(IG_024 , $path).'</td></tr>';
  }
  $text .= "</table>";
  
  return $text;
}

/* render a header for the images which can be added
 */
function render_header(){
  return '<tr>
  	   <td class="forumheader">'.IG_025.'</td>
  	   <td class="forumheader">'.IG_026.'</td>
  	   <td class="forumheader">'.IG_027.'</td>
	  </tr>';
}

/* render one image which can be added
 */
function render_image($img){
  global $frm;
  $tp = new textparse;

  foreach ($img as $key => $value){
    $img[$key] = $tp->formtpa($value);
  }
  
  $img_img = $img['image'];
  $img_add = (isset($img['add'])) ? 1 : 0;
 
  $text  = $frm->form_hidden("imagelist[$img_img][image]", $img['image']);
  $text .= $frm->form_hidden("imagelist[$img_img][path]", $img['path']);
  $text .= $frm->form_hidden("imagelist[$img_img][filesize]", $img['filesize']);
  $text .= $frm->form_hidden("imagelist[$img_img][filedetails]", $img['filedetails']);
  $text .= "<tr>
  	     <td rowspan='2' class='forumheader3'>";
  $text .= $frm->form_checkbox("imagelist[$img_img][add]", "yes", $img_add);
  $text .=  "</td>
  	     <td class='forumheader3'>";
  $text .= $frm->form_text("imagelist[$img_img][name]", 50, $img['name'], 100);
  $text .=  '</td>
  	     <td rowspan="2" class="forumheader3" style="text-align: center; vertical-align: middle">
	       <a href="javascript: open_window(\''.e_FILE.'imagegallery/'. $img['path'] . $img['image']. '\', \'full\')">
	         <img src="admin_preview.php?'.$img['path'].$img['image'].'" alt="'.IG_028.'"/>
	       </a><br />';
  $text .= $img['filesize']." bytes<br />";
  $text .= $img['filedetails'];
  $text .=  "</td>
  	   </tr>
	   <tr>
  	     <td class='forumheader3'>";
  $text .= $frm->form_textarea("imagelist[$img_img][description]", 50, 4, $img['description']);
  $text .=  "</td>
	   </tr>";

  return $text;
}

/* Add the images to the gallery
 */
function add_images($setup, $images){
  /* to parse some texts */
  $tp = new textparse;

  $setup['category_name'] = $tp->tpa($setup['category_name']);
  $setup['new_category_name'] = $tp->tpa($setup['new_category_name']);
  $setup['category_description'] = $tp->tpa($setup['category_description']);

  $good = $bad = 0;

  if (!image_selected($images)) return IG_029;

  if ($setup['mode'] == "new"){
    /* create the new category */
    if ($setup['category_id'] = add_category($setup['new_category_name'], $setup['category_description'], $setup['category_id'])){
      $setup['category_name'] = $setup['new_category_name'];
    } else {
      return IG_030;
    }
  }
 
  /* maximum execution time */
  $max_time = ini_get('max_execution_time') - 5; /* minus 5 secons to be on the safe side */
  list($start_time_usec, $start_time_sec) = explode(' ', microtime());
 
  foreach ($images as $image){
    /* check how much time has elapsed since the start. */
    list($cur_time_usec, $cur_time_sec) = microtime();
    if ($cur_time_sec - $start_time_sec >= $max_time){

      /* if safe mode is off, try to extend script execution time otherwise, skip the last images */
      if (ini_get('safe_mode')){
	break;
      } else {
        list($start_time_usec, $start_time_sec) = explode(' ', microtime());
	set_time_limit(30);
      }

    }
    
    /*todo buiten de foreach halen en merge array gebruiken */
    $image['author'] = USERID.".".USERNAME;
    $image['author_email'] = "";
    $image['author_homepage'] = "";
    $image['newpath'] = $setup['category_id']."-".$setup['category_name']."/";
    
    $image['thumb'] = $tp->tpa($image['thumb']);
    $image['image'] = $tp->tpa($image['image']);
    $image['path'] = $tp->tpa($image['path']);
    $image['name'] = $tp->tpa($image['name']);
    $image['description'] = $tp->tpa($image['description']);
    
    $image['thumb'] = preg_replace('/(.+)(\.[a-z]{3})/i', '\1_thumb\2', $image['image']);
    $image['category'] = $setup['category_id'];
    
    if (isset($image['add'])){
      if (add_image($image)){
        $good++;
      } else {
        $bad++;
      }
    }
  }

  /* total images to be added */
  $tot = 0;
  foreach($images as $image) if (isset($image['add'])) $tot++;
  
  $skipped = $tot - $good - $bad;
  
  $txt = sprintf(IG_031, $good, $bad);
  
  if ($skipped){
    $txt .= sprintf(IG_032, $skipped);
  }
  
  return $txt;
}

/* check if an image is selected for adding
 */
function image_selected($images){
  foreach ($images as $image){
    if (isset($image['add'])) return true;
  }
  return false;
}

/* add one new category
 */
function add_category($name, $description, $parent){
  global $sql, $pref;
  $tp = new textparse;

  /* check if a category with this name already exits in the parent category */
  if ($sql->db_Count("images_category", "(*)", "WHERE category_category = $parent AND category_name = '$name'")) return false;

  /* get some defaults from the parent */
  if (!$sql->db_Select("images_category", "category_image, category_width, category_height, category_class_view, category_class_submit, category_class_admin, category_mode, category_allow_comments", "category_id = $parent")) return false;
  list($category_image, $category_width, $category_height, $category_class_view, $category_class_submit, $category_class_admin, $category_mode, $category_allow_comments) = $sql->db_Fetch();

  $name = $tp->formtpa($name);
  $description = $tp->formtpa($description);

  if (!$sql->db_Insert("images_category", "0, '$name', '$description', '$category_image', $category_width, $category_height, $parent, $category_class_view,$category_class_submit,$category_class_admin, '$category_mode', $category_allow_comments")){
    return false;
  } else {
    /* get new category's id */
    $sql->db_Select("images_category", "category_id", "category_name = '$name' AND category_category = $parent");
    list($category_id) = $sql->db_Fetch();
  }
  umask(0000);
  if (!mkdir(e_FILE."imagegallery/".$category_id."-".$name, octdec($pref['ig_folder_perms']))){
    /* undo the db_Insert*/
    $sql->db_Delete("images_category", "category_name = '$name' AND category_category = $parent");
    return false; 
  } else {
    touch(e_FILE."imagegallery/".$category_id."-".$name."/index.html");
  }

  return $category_id;
}

/* add one image to the database
 */
function add_image($image){
  global $sql, $pref;
  $tp = new textparse;
  require_once("resizer.php");

  if (!resize_image(e_FILE."imagegallery/".$image['path'].$image['image'], e_FILE."imagegallery/".$image['newpath'].$image['thumb'], $pref['ig_thumbnail_width'], $pref['ig_thumbnail_height'])) return false;

  list($image['width'], $image['height']) = getimagesize(e_FILE."imagegallery/".$image['path'].$image['image']);

  if (!rename(e_FILE."imagegallery/".$image['path'].$image['image'], e_FILE."imagegallery/".$image['newpath'].$image['image'])){
    /* undo if something fails */
    unlink( e_FILE."imagegallery/".$image['newpath'].$image['thumb']);
    return false;
  }
  
  foreach ($image as $key => $value){
    $image[$key] = $tp->formtpa($value);
  }
  
  if (!$sql->db_Insert("images", "0, '".$image['name']."', '".$image['description']."', '".$image['thumb']."', '".$image['image']."', ".time().", ".$image['category'].", '".$image['author']."', '".$image['author_email']."', '".$image['author_homepage']."', 0, ".$image['width'].", ".$image['height'])){
    /* undo if something fails */
    rename(e_FILE."imagegallery/".$image['newpath'].$image['image'], e_FILE."imagegallery/".$image['path'].$image['image']);
    unlink( e_FILE."imagegallery/".$image['newpath'].$image['thumb']);
    return false;  
  }
  return true;
}

function get_paths(){
  $dir = opendir(e_FILE . "imagegallery/");
  $list = array();
  while (false !== ($file = readdir($dir))){
    if ($file != "." && $file != ".." && is_dir(e_FILE."imagegallery/".$file) && !is_category_name($file)){
      $list[] = $file;
    }
  }
  closedir($dir);

  /* sort the list */
  natcasesort($list);

  return $list;
}

/* checks if the given $categ_name is the name of an existing category folde
 */
function is_category_name($category_name){
  global $sql;

  if ($category_name == "category_thumbs" || $category_name == '0-submitted_images') return true;
  return ($sql->db_Count("images_category", "(category_id)", "WHERE CONCAT(category_id, '-', category_name) = '$category_name';"));
}

/* check if there is something wrong with the $setup
 */
function check_settings($setup){
  global $sql;
  $tp = new textparse;
  
  if (!is_writable(e_FILE."imagegallery/".$setup['path'])) $error[0] = true;

  if (!is_writable(e_FILE."imagegallery/".$setup['category_id']."-".$setup['category_name'])) $error[1] = true;

  if (!is_writable(e_FILE."imagegallery")) $error[2] = true;
  
  $sql->db_Select_gen("SELECT count(*)
  	FROM ".MPREFIX."images_category cat 
		INNER JOIN ".MPREFIX."images_category subcat ON cat.category_id = subcat.category_category
	WHERE cat.category_id = ".$setup['category_id']." AND subcat.category_name = '".$setup['new_category_name']."'");
  list($count) = $sql->db_Fetch();

  if ($count) $error[3] = true;
  
  if (!check_no_quotes($tp->formtparev($setup['new_category_name']))) $error[4] = true;

  return isset($error) ? $error : false;
}

?>
