<?php
/*
+---------------------------------------------------------------+
|       e107 website system imagegallery plugin
|       e107_plugins/imagegallery/admin_browse.php
|
|        Mark Pustjens 2003
|       http://unkie.org
|       mark@unkie.org
|
|       Released under the terms and conditions of the
|       GNU General Public License (http://gnu.org).    
+---------------------------------------------------------------+
*/

require_once("../../class2.php");

@include("languages/imagegallery_".e_LANGUAGE.".php");
@include("languages/imagegallery_English.php");

/* some handy functions */
require_once("functions.php");

/* check authorisation */
list($category) = explode(".", e_QUERY);
$category = intval($category);
if ($category <= 0) $category = 1;
if(!is_authorized($category, "admin") && !getperms("P")){
  header('location:'.SITEURL.'index.php');
  exit;
}

/*
 * render the options bar, categories and images
 */
$headertxt = render_header();
$cattxt = render_categories($category);
$imgtxt = render_images($category);
$opttxt = render_opts($category);
if ($cattxt == "" && $imgtxt == ""){
  $headertxt .= render_none();
}
if ($category == 1 && getperms("P") && $sql->db_Count('images', '(*)', 'WHERE img_category=0')){
  $approve = render_approve();
}

/*
 * now display the page
 */
if (ADMIN) require_once(e_ADMIN.'auth.php'); else require_once(HEADERF);
$ns->tablerender(IG_033, render_page($opttxt));
$ns->tablerender(IG_034, render_page($headertxt.$cattxt.$imgtxt));
if (isset($approve)){
  $ns->tablerender(IG_035, render_page($headertxt.$approve));
}
if (ADMIN) require_once(e_ADMIN.'footer.php'); else require_once(FOOTERF);

/*******************************************************************/

/* put it all together */
function render_page($txt){
  return '<table style="width: 100%;">'.$txt.'</table>';
}

/* render upload approval section */
function render_approve(){
  $sql = new DB;

  $image_count = $sql->db_Select("images", "img_id, img_name, img_category, img_image", "img_category=0");
  
  if ($image_count){
    $mytxt = "";
    /* for every category render a row */
    for ($i = 0; $i < $image_count; $i++){
      $mytxt .= render_approve_image($sql->db_Fetch());
    }
    return $mytxt;
  } else {
    return false;
  }
}

/* render categories */
function render_categories($category){
  $sql = new DB;

  $category_count = $sql->db_Select("images_category", "category_id, category_name, category_class_admin", "category_category=$category");

  $mytxt = render_parent($category);
  if ($category_count){
    /* for every category render a row */
    for ($i = 0; $i < $category_count; $i++){
      $mytxt .= render_category($sql->db_Fetch());
    }
  }
  return $mytxt;
}
 

/* render images */
function render_images($category){
  $sql = new DB;

  $image_count = $sql->db_Select("images", "img_id, img_name, img_category", "img_category=$category");
  
  if ($image_count){
    $mytxt = "";
    /* for every category render a row */
    for ($i = 0; $i < $image_count; $i++){
      $mytxt .= render_image($sql->db_Fetch());
    }
    return $mytxt;
  } else {
    return false;
  }
}

/* render a row for a category */
function render_category($data){
  extract($data);

  if (!check_class($category_class_admin) && !getperms('P')) return '';

  $img = e_IMAGE."filemanager/folder.png";
  $category_opts = render_category_opts($category_id);
  return "<tr>
  	    <td class='forumheader3'><img src='$img' alt='$category_name' /></td>
	    <td class='forumheader3'>$category_id</td>
	    <td class='forumheader3'>
	      <a href='admin_browse.php?$category_id'>$category_name</a>
	    </td>
	    <td class='forumheader3'>$category_opts</td>
          </tr>";
}

/* render a row for the parent category */
function render_parent($category){
  $img = e_IMAGE."filemanager/folder.png";
  $sql = new DB;

  if ($category == 1){
    return;
  } else {
    $sql->db_Select("images_category", "category_category AS category", "category_id=$category");
    extract($sql->db_Fetch());
  }

  if (!is_authorized($category, "admin")) {
    return;
  }
  
  return '<tr>
  	    <td class="forumheader3"><img src="'.$img.'" alt="'.IG_036.'" /></td>
	    <td class="forumheader3">...</td>
	    <td class="forumheader3" colspan="2">
	      <a href="admin_browse.php?$category">'.IG_036.'</a>
	    </td>
  	  </tr>';
}

function render_approve_image($data){
  global $FILES_DIRECTORY;
  extract($data);

  $img = e_IMAGE."filemanager/png.png";
  return '<tr>
  	    <td class="forumheader3"><img src="'.$img.'" alt="'.$img_name.'" /></td>
	    <td class="forumheader3">'.$img_id.'</td>
	    <td class="forumheader3">'.$img_name.'</td>
	    <td class="forumheader3">
	      <a href="submit.php?approve.'.$img_id.'">'.IG_037.'</a> - 
	      <a href="admin_del.php?0.'.$img_id.'">'.IG_038.'</a> - 
	      <a href="'.$FILES_DIRECTORY.'imagegallery/0-submitted_images/'.$img_image.'">'.IG_039.'</a>
	    </td>
          </tr>';
}

/* render a row for an image */
function render_image($data){
  extract($data);

  $img = e_IMAGE."filemanager/png.png";
  $img_opts = render_image_opts($img_id, $img_category);
  return "<tr>
  	    <td class='forumheader3'><img src='$img' alt='$img_name' /></td>
	    <td class='forumheader3'>$img_id</td>
	    <td class='forumheader3'>$img_name</td>
	    <td class='forumheader3'>$img_opts</td>
          </tr>";
}

function render_header(){
  return '<tr>
  	   <td class="forumheader" style="width: 5%;">
	     <img src="'.e_IMAGE.'filemanager/updir.png" alt="'.IG_036.'" />
	   </td>
  	   <td class="forumheader" style="width: 10%;"><b>'.IG_040.'</b></td>
  	   <td class="forumheader" style="width: 30%;"><b>'.IG_041.'</b></td>
  	   <td class="forumheader"><b>'.IG_042.'</b></td>
	 </tr>';
}

function render_none(){
  return '<tr><td colspan="4" class="forumheader3">'.IG_043.'</td></tr>';
}

function render_opts($category){
  return '<a href="browse.php?'.$category.'">'.IG_044.'</a> - 
	  <a href="admin_category.php?edit.'.$category.'">'.IG_045.'</a> - 
	  <a href="admin_batchadd.php?'.$category.'">'.IG_046.'</a> - 
	  <a href="admin_category.php?new.'.$category.'">'.IG_047.'</a> - 
	  <a href="admin_image.php?new.'.$category.'">'.IG_048.'</a>';
}

function render_category_opts($category_id){
  return '<a href="admin_category.php?edit.'.$category_id.'">'.IG_037.'</a> - 
  	  <a href="admin_del.php?'.$category_id.'.0">'.IG_038.'</a>';
}

function render_image_opts($image_id, $image_category){
  return '<a href="admin_image.php?edit.'.$image_category.'.'.$image_id.'">'.IG_037.'</a> - 
  	  <a href="admin_del.php?'.$image_category.'.'.$image_id.'">'.IG_038.'</a> - 
  	  <a href="view.php?'.$image_id.'.6">'.IG_039.'</a>';
}
