<?php
/*
+---------------------------------------------------------------+
|       e107 website system imagegallery plugin
|       e107_plugins/imagegallery/admin_category.php
|
|        Mark Pustjens 2003
|       http://unkie.org
|       mark@unkie.org
|
|       Released under the terms and conditions of the
|       GNU General Public License (http://gnu.org).    
+---------------------------------------------------------------+
*/

require_once("../../class2.php");

@include("languages/imagegallery_".e_LANGUAGE.".php");
@include("languages/imagegallery_English.php");

/* some handy functions */
require_once("functions.php");
require_once(e_HANDLER."emote.php");

/* check authorisation */
list($mode, $category) = explode(".", e_QUERY);
$category = intval($category);
$mode = strval($mode);
if($category == 0 || ($mode != "new" && $mode != "edit") || (!is_authorized($category, "admin") && !getperms("P"))){
  header('location:'.SITEURL.'index.php'); 
  exit;
}

/* get some vars */
$cat = $_POST['cat'];
$cat['category_id'] = $category;
$ig_mode = $_POST['ig_mode'];

/* if cancel was pushed, return */
if (isset($_POST['cancel'])){
  header('location: '.SITEURL.$PLUGINS_DIRECTORY.'imagegallery/admin_browse.php?'.$category);
}

/* create/update a category is requested*/
switch ($mode){
  case "new":
    list($cat, $ig_mode) = get_defaults($cat, $ig_mode);
    /* save the new category */
    if (isset($_POST['save'])){
      $msg = add_category($cat, $ig_mode);
      if ($msg === true){
	header('location: '.SITEURL.$PLUGINS_DIRECTORY.'imagegallery/admin_browse.php?'.$category);
      }
    }
    break; 
  case "edit":
    /* if `Save' was clicked, save the chages */
    if (isset($_POST['save'])) $msg = edit_category($cat, $ig_mode); 
    unset($cat, $ig_mode);

    /* get the category date */
    $sql->db_Select("images_category", "category_id, category_name, category_description, category_image, category_class_view, category_class_submit, category_class_admin, category_allow_comments, category_category", "category_id=".$category);
    $cat = $sql->db_Fetch();
    $ig_mode = get_default_mode($cat['category_id']);

    break;
  default:
    header('location: '.SITEURL.$PLUGINS_DIRECTORY.'imagegallery/admin_browse.php?');
}

if (ADMIN) require_once(e_ADMIN.'auth.php'); else require_once(HEADERF);
if ($msg) $ns->tablerender(IG_049, "<strong>".$msg."</strong>");
$ns->tablerender(IG_050, render_configuration($mode, $cat, $ig_mode));
if (ADMIN) require_once(e_ADMIN.'footer.php'); else require_once(FOOTERF);

/*********************************************************************/

/* sets defaults for the category data and image gallery modes*/
function get_defaults($cat, $ig_mode){
  /* to parse some texts */
  $tp = new textparse;

  $mode = get_default_mode($cat['category_id']);

  $cat['category_name'] = $tp->formtpa($cat['category_name']);
  $cat['category_description'] = $tp->formtpa($cat['category_description']);
  $cat['category_image'] = $tp->formtpa($cat['category_image']);

  $cat['category_class_view'] = intval($cat['category_class_view']);
  $cat['category_class_submit'] = intval($cat['category_class_submit']);

  if (ADMIN || getperms('P')){
    $cat['category_class_admin'] = intval($cat['category_class_admin']);
  } else {
    $cat['category_class_admin'] = get_default_perms($cat['category_id'], 'admin');
  }
  $ig_mode['view'] = intval($ig_mode['view']);
  $ig_mode['img'] = intval($ig_mode['img']);
  $ig_mode['cat'] = intval($ig_mode['cat']);
  $cat['category_allow_comments'] = intval($cat['category_allow_comments']);

  if (!$cat['category_name']) $cat['category_name'] = "New Category";
  if (!$cat['category_description']) $cat['category_description'] = IG_001;
  if ($cat['category_class_view'] < 0) $cat['category_class_view'] = "0";
  if ($cat['category_class_submit'] < 0) $cat['category_class_submit'] = "255";
  if ($cat['category_class_admin'] <= 0 || $cat['category_class_admin'] == 252 || $cat['category_class_admin'] == 253) $cat['category_class_admin'] = "254";
  if ($ig_mode['view'] <= 0) $ig_mode['view'] = $mode['view'];
  if ($ig_mode['img'] < 0) $ig_mode['img'] = $mode['img'];
  if ($ig_mode['cat'] < 0) $ig_mode['cat'] = $mode['cat'];

  $cat['category_mode'] = $ig_mode['view'].".".$ig_mode['img'].".".$ig_mode['cat'];

  return array($cat, $ig_mode);
}

/* add a new category */
function add_category($cat){
  global $sql, $pref;
  $tp = new textparse;

  if (!check_no_quotes($tp->formtparev($cat['category_name']))) return IG_015;

  /* check if a category with this name already exits in the parent category */
  if ($sql->db_Count("images_category", "(*)", "WHERE category_category=".$cat['category_id']." AND category_name='".$cat['category_name']."'")) return IG_051;

  list($cat['category_width'], $cat['category_height']) = getimagesize(e_FILE."imagegallery/category_thumbs/".$cat['category_image']);

  if(!$sql->db_Insert("images_category", 
		"0,
                '".$cat['category_name']."', 
                '".$cat['category_description']."', 
                '".$cat['category_image']."', 
                ".$cat['category_width'].",
                ".$cat['category_height'].",
                ".$cat['category_id'].", 
                ".$cat['category_class_view'].",
                ".$cat['category_class_submit'].",
                ".$cat['category_class_admin'].",
                '".$cat['category_mode']."',
                ".$cat['category_allow_comments'])){

    return IG_052;
  } else {
    /* get new category's id */
    $sql->db_Select("images_category", "category_id", "category_name = '".$cat['category_name']."' AND category_category = ".$cat['category_id']);
    list($category_id) = $sql->db_Fetch();
  }
  
  umask(0000);
  if (!mkdir(e_FILE."imagegallery/".$category_id."-".$cat['category_name'], octdec($pref['ig_folder_perms']))){
    /* undo the db_Insert*/
    $sql->db_Delete("images_category", "category_name = '".$cat['category_name']."' AND category_category = ".$cat['category_id']);
    return "Could not create the new category folder!";
  } else {
    touch(e_FILE."imagegallery/".$category_id."-".$cat['category_name']."/index.html");
  }

  return true;
}

/* edit a category */
function edit_category($cat, $ig_mode){
  global $sql;
  $tp = new textparse;
  $mode = get_default_mode($cat['category_id']);

  if (!check_no_quotes($tp->formtparev($cat['category_name']))) return IG_015;

  if ($sql->db_Count("images_category", "(*)", "WHERE category_category=".$cat['category_category']." AND category_name='".$cat['category_name']."' AND category_id<>".$cat['category_id'],true)) return IG_051;
  
  /* first check the data */
  if ($cat['category_name'] != $cat['org_category_name']){
    if(!rename(e_FILE."imagegallery/".$cat['category_id']."-".$cat['org_category_name'], e_FILE."imagegallery/".$cat['category_id']."-".$cat['category_name'])) return 'Failed to rename the category folder';
  }

  list($cat, $ig_mode) = get_defaults($cat, $ig_mode);
  list($cat['category_width'], $cat['category_height']) = getimagesize(e_FILE."imagegallery/category_thumbs/".$cat['category_image']);

  $sql = new DB;

  if($sql->db_Update("images_category", 
  		  "category_name='".$cat['category_name']."', 
		   category_description='".$cat['category_description']."', 
		   category_image='".$cat['category_image']."', 
		   category_width=".$cat['category_width'].", 
		   category_height=".$cat['category_height'].", 
		   category_class_view=".$cat['category_class_view'].",
		   category_class_submit=".$cat['category_class_submit'].",
		   ". ((ADMIN || getperms('P')) ? "category_class_admin=".$cat['category_class_admin']."," : '')."
		   category_mode='".$cat['category_mode']."',
		   category_allow_comments=".$cat['category_allow_comments']."
		   WHERE category_id=".$cat['category_id'])){
    return IG_053;
  } else {
    return IG_054;
  }
}

/* render the configuration form */
function render_configuration($mode, $cat, $ig_mode){
  require_once(e_HANDLER."form_handler.php");
  require_once(e_HANDLER."userclass_class.php");
  require_once("functions.php");
  $frm = new form;
  $tp = new textparse;

  $images = get_images("category_thumbs/");
  
  $txt = $frm->form_open("post", e_SELF."?".e_QUERY);
  $txt .= '<table style="width: 95%;" class="fborder">
  	    <tr><td class="forumheader" colspan="2">'.IG_055.'</td></tr>
  	    <tr>
	      <td class="forumheader3">'.IG_056.'</td>
	      <td class="forumheader3">';
  $txt .= $frm->form_text("cat[category_name]", 35, $tp->formtparev($cat['category_name'], 100));
  $txt .=    '</td>
  	    </tr>
  	    <tr>
	      <td class="forumheader3">'.IG_057.'</td>
	      <td class="forumheader3">';
  $txt .= $frm->form_textarea("cat[category_description]", 50, 4, $tp->formtparev($cat['category_description']));
  $txt .=    '</td>
  	    </tr>
            <tr>
              <td class="forumheader3">'.IG_058.'</td>
              <td class="forumheader3">';
  $txt .= $frm->form_select_open("cat[category_image]");
  $txt .= $frm->form_option(IG_059, 0, "folder.png");
  foreach($images as $image){
    $txt .= $frm->form_option($image,($tp->formtpa($cat['category_image']) == $image ? 1 : 0),$image);
  }
  $txt .= $frm->form_select_close();
  $txt .=    '</td>
            </tr>
  	    <tr>
	      <td class="forumheader3">'.IG_060.'</td>
	      <td class="forumheader3">';
  $txt .= $frm->form_checkbox("cat[category_allow_comments]", 1, $cat['category_allow_comments']);
  $txt .=    '</td>
  	    </tr>
  	    <tr><td class="forumheader" colspan="2">'.IG_061.'</td></tr>
  	    <tr>
	      <td class="forumheader3">'.IG_062.'</td>
	      <td class="forumheader3">';
  $txt .= r_userclass("cat[category_class_view]", $cat['category_class_view']);
  $txt .=    '</td>
  	    </tr>
  	    <tr>
	      <td class="forumheader3">'.IG_063.'</td>
	      <td class="forumheader3">';
  $txt .= r_userclass("cat[category_class_submit]", $cat['category_class_submit']);
  $txt .=    '</td>
  	    </tr>';
  if (ADMIN || getperms('P')){
    $txt .= '<tr>
	      <td class="forumheader3">'.IG_064.'</td>
	      <td class="forumheader3">';
    $txt .= r_userclass("cat[category_class_admin]", $cat['category_class_admin'], "off", "admin,classes");
    $txt .=  "</td>
  	    </tr>";
  }
  $txt .=  '<tr><td class="forumheader" colspan="2">'.IG_065.'</td></tr>
  	    <tr>
	      <td class="forumheader3">'.IG_066.'</td>
	      <td class="forumheader3">'.IG_067.'<br />';
  $txt .= mode_category_list('ig_mode[cat]', $ig_mode['cat']);
  $txt .= '<br />'.IG_068.'<br />';
  $txt .= mode_image_list('ig_mode[img]', $ig_mode['img']);
  $txt .= '<br />'.IG_069.'<br />';
  $txt .= mode_view_list('ig_mode[view]', $ig_mode['view']);
  $txt .=    '</td>
  	    </tr>
  	    <tr><td class="forumheader" colspan="2">'.IG_070.'</td></tr>
	    <tr>
	      <td colspan="2" style="text-align: center;" class="forumheader3">';
  $txt .= $frm->form_button("submit", "save", IG_071);
  $txt .= $frm->form_button("submit", "cancel", IG_072);
  $txt .= $frm->form_hidden("cat[org_category_name]", $tp->formtpa($cat['category_name']));
  $txt .= $frm->form_hidden("cat[category_category]", $tp->formtpa($cat['category_category']));
  $txt .=    "</td>
	    </tr>
  	  </table>";
  $txt .= $frm->form_close();

  return $txt;
}
?>
