<?php
/*
+---------------------------------------------------------------+
|       e107 website system imagegallery plugin
|       e107_plugins/imagegallery/admin_del.php
|
|        Mark Pustjens 2003
|       http://unkie.org
|       mark@unkie.org
|
|       Released under the terms and conditions of the
|       GNU General Public License (http://gnu.org).    
+---------------------------------------------------------------+
*/

require_once("../../class2.php");

@include("languages/imagegallery_".e_LANGUAGE.".php");
@include("languages/imagegallery_English.php");

/* some handy functions */
require_once("functions.php");

/*
 * which category/image are we deleting
 */
list($category, $image) = explode(".", e_QUERY);
$category = intval($category);
$image = intval($image);

/*
 * check the vars
 */
if ($image == 0 && $category == 1) $category = 0;

/* check authorisation */
if($category < 0 || $image < 0 || (!is_authorized($category, "admin") && !getperms("P"))){
  header('location:'.SITEURL.'index.php');
  exit;
}

/*
 * check if cancel or delete was clicked
 */
if (isset($_POST['cancel'])){

  $sql->db_Select("images_category", "category_category AS category", "category_id=$category");
  extract($sql->db_Fetch());

  header('location: '.SITEURL.$PLUGINS_DIRECTORY.'imagegallery/admin_browse.php?'.$category);

} else if (isset($_POST['delete'])){

  require_once(e_HANDLER."form_handler.php");

  $mytxt = render_delete($image, $category, $_POST['method_cat'], $_POST['method_img']);

/* render deletion config form */
} else {
 
  require_once(e_HANDLER."form_handler.php");

  if ($image){
    $mytxt = render_image($image, $category);
  } else {
    $mytxt = render_category($category);
  }

}

/*
 * now display the page
 */
if (ADMIN) require_once(e_ADMIN.'auth.php'); else require_once(HEADERF);
$ns->tablerender(IG_090, $mytxt);
if (ADMIN) require_once(e_ADMIN.'footer.php'); else require_once(FOOTERF);

/*******************************************************************/

/* delete images and show success/failure and a `back' button */
function render_delete($image, $category, $method_cat, $method_img){
  $frm = new form;

  if ($image){
  
    $back = $category;
    $mytxt = delete_image($image, $category, $method_img);
    
  } else {
    $sql = new DB;
  
    if ($sql->db_Select("images_category", "category_category AS back", "category_id=$category")) {
      extract($sql->db_Fetch());
    } else {
      $back = 1;
    }

    $mytxt = delete_category($category, $method_cat, $method_img);

  }

  $mytxt .= $frm->form_open("post", "admin_browse.php?$back");
  $mytxt .= "<br /><div style='text-align: center;'>";
  $mytxt .= $frm->form_button("submit", "back", IG_019);
  $mytxt .= "</div>";
  $mytxt .= $frm->form_close();

  return $mytxt;
}

/* show the delete form for categories */
function render_category($category){
  $sql = new DB;
  $frm = new form;

  $category_categories = $sql->db_Count('images_category', '(*)', 'WHERE category_category='.$category);
  if ($sql->db_Select('images', 'SUM(img_views) AS views', 'img_category='.$category, true)) list($views_total) = ($sql->db_Fetch());
  if (!$views_total) $views_total = '0';
  $category_count = $sql->db_Select_gen("SELECT cat.category_id, cat.category_name, COUNT(img.img_id) as category_images FROM ".MPREFIX."images_category AS cat LEFT JOIN ".MPREFIX."images AS img ON cat.category_id = img.img_category WHERE category_id=$category GROUP BY cat.category_id");

  if ($category_count){
    extract($sql->db_Fetch());

    $mytxt = $frm->form_open("post", e_SELF."?".e_QUERY);
    $mytxt .= '<table style="width: 95%;" class="fborder">
                <tr>
		  <td class="forumheader" colspan="2">'.IG_091.'</td>
		<tr>
		<tr>
		  <td class="forumheader3" colspan="2">'.sprintf(IG_092, $category_id, $category_name).sprintf(IG_093, $category_categories).sprintf(IG_094, $category_images, $views_total).'</td>
		</tr>
		</tr>
		  <td class="forumheader3">'.IG_095.'</td>
		  <td class="forumheader3">';
    $mytxt .= $frm->form_select_open("method_cat");
    $mytxt .= $frm->form_option(IG_096 ,1,"move");
    $mytxt .= $frm->form_option(IG_097 ,0,"delete");
    $mytxt .= $frm->form_select_close();
    $mytxt .=    '</td>
    		<tr>
    		</tr>
		  <td class="forumheader3">'.IG_098.'</td>
		  <td class="forumheader3">';
    $mytxt .= $frm->form_select_open("method_img");
    $mytxt .= $frm->form_option(IG_099 ,1,"move");
    $mytxt .= $frm->form_option(IG_100 ,0,"moveup");
    $mytxt .= $frm->form_option(IG_101 ,0,"delete");
    $mytxt .= $frm->form_select_close();
    $mytxt .=     '</td>
    		 <tr>
		 <tr>
		   <td style="text-align: center;" class="forumheader3" colspan="2">';
    $mytxt .= $frm->form_button("submit", "delete", IG_102);
    $mytxt .= $frm->form_button("submit", "cancel", IG_072);
    $mytxt .=     "</td>
		 </tr>
	      </table>";
    $mytxt .= $frm->form_close();

    return $mytxt;
  } else {
    return IG_103;
  }
}

function render_image($image, $category){
  $sql = new DB;
  $frm = new form;
  
  $image_exists = $sql->db_Select("images", "img_id, img_name, img_views", "img_id=$image AND img_category=$category");

  if ($image_exists) {
    extract($sql->db_Fetch());

    $mytxt = $frm->form_open("post", e_SELF."?".e_QUERY);
    $mytxt .= '<table style="width: 95%;" class="fborder">
    		 <tr>
		   <td class="forumheader" colspan="2">'.IG_104.'</td>
		 </tr>
		<tr>
		  <td class="forumheader3" colspan="2">'.sprintf(IG_105, $image, $img_name, $img_views).'</td>
		</tr>
		 <tr>
		   <td class="forumheader3">'.IG_106.'</td>
		   <td class="forumheader3">';
    $mytxt .= $frm->form_select_open("method_img");
    $mytxt .= $frm->form_option(IG_099 ,1,"move");
    $mytxt .= $frm->form_option(IG_101 ,0,"delete");
    $mytxt .= $frm->form_select_close();
    $mytxt .=     '</td>
    		 </tr>
		 <tr>
		   <td style="text-align: center;" class="forumheader3" colspan="2">';
    $mytxt .= $frm->form_button("submit", "delete", IG_102);
    $mytxt .= $frm->form_button("submit", "cancel", IG_072);
    $mytxt .=     '</td>
		 </tr>
    	       </table>';
    $mytxt .= $frm->form_close();

    return $mytxt;
  } else {
    return IG_107;
  }
}

/* function to delete an image */
function delete_image($image, $category, $method){
  $sql = new DB;

  if ($method != "move" && $method != "delete"){
    $newcategory = $method;
    $method = "moveup";
  }

  /* check if the image being modified exists */
  if ($sql->db_Select("images", "img_image, img_thumb", "img_id=$image AND img_category=$category")){
    extract($sql->db_Fetch());
  } else {
    return IG_107;
  }
  
  $img_path = get_img_path($img_image, $category, false);
  $tmb_path = get_img_path($img_thumb, $category, false);

  switch ($method){
    /*TODO better checking for success */
    /* move the image to the upload folder */
    case "move":
      $new_img_path = e_FILE."imagegallery/upload/".$img_image;
      rename($img_path, $new_img_path);
      unlink($tmb_path);
      $sql->db_Delete("images", "img_id=$image AND img_category=$category");

      return sprintf(IG_108, $img_image);
      break;

    /* move the file to the parent category */
    case "moveup":
      $new_img_path = get_img_path($img_image, $newcategory, false);
      $new_tmb_path = get_img_path($img_thumb, $newcategory, false);
      rename($img_path, $new_img_path);
      rename($tmb_path, $new_tmb_path);
      $sql->db_Update("images", "img_category=$newcategory WHERE img_id=$image AND img_category=$category");

      return sprintf(IG_109, $img_image, $category);
      break;
    /* delete the file alltogehter */
    case "delete":
      /* if deleting fails, move to the uplaod folder */
      if (!unlink($img_path)){
        delete_image($image, $category, "move");
      }
      unlink($tmb_path);
      $sql->db_Delete("images", "img_id=$image AND img_category=$category");

      return sprintf(IG_110, $img_image);
      break;
  }

  return true;
}

function delete_category($category, $method_cat, $method_img){
  $sql = new DB;

  /* find the parent category to move other categories to */
  if ($sql->db_Select("images_category", "category_category AS parent", "category_id=$category")) {
    extract($sql->db_Fetch());
  
    switch ($method_cat){
    
      /* move subcategories to this category's parent category */
      case "move":

	  /* first move subcategories */
	  $sql->db_Update("images_category", "category_category=$parent WHERE category_category=$category");
	
	  /* then delete the images in this category */
	  $sql->db_Select("images", "img_id", "img_category=$category");
	  while(list($img_id) = $sql->db_Fetch()){
	    delete_image($img_id, $category, $method_img == "moveup" ? $parent : $method_img);
	  }

	  /* then delete this category*/
	  delete_category($category, "delete", $method_img);

	break;

      case "delete":

	/* delete all the categories in this category */
	$sql->db_Select("images_category", "category_id", "category_category=$category");
	while(list($category_id) = $sql->db_Fetch()){
	  delete_category($category_id, "delete", $method_img);
	}

	/* delete the images in this category */
	$sql->db_Select("images", "img_id", "img_category=$category");
	while(list($img_id) = $sql->db_Fetch()){
	  delete_image($img_id, $category, $method_img == "moveup" ? $parent : $method_img);
	}

	/* delete this category (including the folder) */
	$category_path = get_img_path("", $category, false);
	unlink($category_path."/index.html");
	rmdir($category_path);
	$sql->db_Delete("images_category", "category_id=$category");
      break;
    }

    return sprintf(IG_111, $category);
    
  } else {
  
    return sprintf(IG_112, $category);
    
  }

}
