<?php
/*
+---------------------------------------------------------------+
|       e107 website system imagegallery plugin
|       e107_plugins/imagegallery/admin_image.php
|
|        Mark Pustjens 2003
|       http://unkie.org
|       mark@unkie.org
|
|       Released under the terms and conditions of the
|       GNU General Public License (http://gnu.org).    
+---------------------------------------------------------------+
*/

require_once("../../class2.php");

@include("languages/imagegallery_".e_LANGUAGE.".php");
@include("languages/imagegallery_English.php");

/* some handy functions */
require_once("functions.php");

/* check authorisation */
list($mode, $category, $image) = explode(".", e_QUERY);
$image = intval($image);
$category = intval($category);
$mode = strval($mode);
if(($image == 0 && $mode != "new") || ($mode != 'new' && $mode != 'edit') || (!is_authorized($category, "admin") && !getperms('P'))){
  header('location:'.SITEURL.'index.php'); 
  exit;
}

/* get some vars */
$img = $_POST['img'];
$img['img_id'] = $image;
$img['img_category'] = $category;

/* if cancel was pushed, return */
if (isset($_POST['cancel'])){
  header('location: '.SITEURL.$PLUGINS_DIRECTORY.'imagegallery/admin_browse.php?'.$category);
}

list($img, $msg2) = get_defaults($img);

/* create/update an image as requested */
switch ($mode){
  case "new":
    /* save the new image */
    if (isset($_POST['save'])){
      $msg = add_img($img);
      if ($msg === true){
	header('location: '.SITEURL.$PLUGINS_DIRECTORY.'imagegallery/admin_browse.php?'.$category);
      }
    }
    break; 
  case "edit":
    /* if `Save' was clicked, save the chages */
    if (isset($_POST['save'])) $msg = edit_img($img); 
    unset($img);

    /* get the image date */
    $sql->db_Select("images", "img_id, img_name, img_description", "img_id=".$image." AND img_category=".$category);
    $img = $sql->db_Fetch();

    break;
  default:
    header('location: '.SITEURL.$PLUGINS_DIRECTORY.'imagegallery/admin_browse.php?');
}

if (ADMIN) require_once(e_ADMIN.'auth.php'); else require_once(HEADERF);
if ($msg2) echo $msg2;
if ($msg) $ns->tablerender(IG_049, '<strong>'.$msg.'</strong>');
$ns->tablerender(IG_113, render_configuration($mode, $img));
if (ADMIN) require_once(e_ADMIN.'footer.php'); else require_once(FOOTERF);

/*********************************************************************/

/* sets defaults for the image */
function get_defaults($img){
  /* to parse some texts */
  $tp = new textparse;

  /* find out what image was uploaded, if any */
  if (isset($_FILES['file_userfile'])){
    require_once(e_HANDLER."upload_handler.php");

    ob_start();
    $uploaded = file_upload(e_FILE."imagegallery/upload/", true);
    $msg = ob_get_contents();
    ob_end_clean();

    if ($uploaded) {
      $img['path'] = "upload/";
      $img['newpath'] = get_img_path("", $img['img_category'], "false");
     
      $img['img_image'] = $uploaded[0]["name"];
      $img['img_thumb'] = preg_replace('/(.+)(\.[a-z]{3})/i', '\1_thumb\2', $img['img_image']);

      $img['img_author'] = USERID.".".USERNAME;
      $img['img_author_email'] = "";
      $img['img_author_homepage'] = "";
    }
  }

  $img['img_name'] = $tp->formtpa($img['img_name']);
  $img['img_description'] = $tp->formtpa($img['img_description']);

  return array($img, $msg);
}

/* add a new image */
function add_img($img){
  global $sql, $pref;
  require_once("resizer.php");

  if (!isset($img['img_image']) || !check_no_quotes($img['img_image'])) return IG_114;

  if ($sql->db_Count("images", "(*)", "WHERE img_category=".$img['img_category']." AND img_image='".$img['img_image']."'")) return IG_115;

  if (!resize_image(e_FILE."imagegallery/".$img['path'].$img['img_image'], $img['newpath'].$img['img_thumb'], $pref['ig_thumbnail_width'], $pref['ig_thumbnail_height'])) return IG_116;

  list($img['width'], $img['height']) = getimagesize(e_FILE."imagegallery/".$img['path'].$img['img_image']);
      
  if (!rename(e_FILE."imagegallery/".$img['path'].$img['img_image'], e_FILE."imagegallery/".$img['newpath'].$img['img_image'])){
    /* undo if something fails */
    unlink( e_FILE."imagegallery/".$img['newpath'].$img['img_thumb']);
    return "";
  }

  if (!$sql->db_Insert("images",
  			"0,
			'".$img['img_name']."',
			'".$img['img_description']."',
			'".$img['img_thumb']."',
			'".$img['img_image']."',
			".time().",
			".$img['img_category'].",
			'".$img['img_author']."',
			'".$img['img_author_email']."',
			'".$img['img_author_homepage']."',
			0,
			".$img['width'].",
			".$img['height'])){
    /* undo if something fails */
    rename(e_FILE."imagegallery/".$image['newpath'].$image['img_image'], e_FILE."imagegallery/".$image['path'].$image['img_image']);
    unlink( e_FILE."imagegallery/".$image['newpath'].$image['img_thumb']);
    return IG_117;
  }

  return true;
}

/* edit an image */
function edit_img($img){

  $sql = new DB;

  if($sql->db_Update("images", 
  		  "img_name='".$img['img_name']."', 
		   img_description='".$img['img_description']."' 
		   WHERE img_id=".$img['img_id']." AND img_category=".$img['img_category'])){
    return IG_053;
  } else {
    return IG_054;
  }
}

/* render the configuration form */
function render_configuration($mode, $img){
  require_once(e_HANDLER."form_handler.php");
  $frm = new form;
  $tp = new textparse;

  if ($mode == "new"){
    $txt = $frm->form_open("post", e_SELF."?".e_QUERY, "", "", " enctype='multipart/form-data'");
  } else {
    $txt = $frm->form_open("post", e_SELF."?".e_QUERY);
  }
  $txt .= '<table style="width: 95%;" class="fborder">
  	    <tr><td class="forumheader" colspan="2">'.IG_055.'</td></tr>';
  if ($mode == "new"){
    $txt .='<tr>
	      <td class="forumheader3">'.IG_018.'</td>
	      <td class="forumheader3">';
    $txt .= $frm->form_file('file_userfile[]', 40);
    $txt .=  '</td>
    	    </tr>';
  };
  $txt .=  '<tr>
	      <td class="forumheader3">'.IG_056.'</td>
	      <td class="forumheader3">';
  $txt .= $frm->form_text("img[img_name]", 35, $tp->formtpa($img['img_name'], 100));
  $txt .=    '</td>
  	    </tr>
  	    <tr>
	      <td class="forumheader3">'.IG_057.'</td>
	      <td class="forumheader3">';
  $txt .= $frm->form_textarea("img[img_description]", 50, 4, $tp->formtpa($img['img_description']));
  $txt .=    '</td>
  	    </tr>
  	    <tr><td class="forumheader" colspan="2">'.IG_070.'</td></tr>
	    <tr>
	      <td colspan="2" style="text-align: center;" class="forumheader3">';
  $txt .= $frm->form_button('submit', 'save', IG_071);
  $txt .= $frm->form_button('submit', 'cancel', IG_072);
  $txt .=    "</td>
	    </tr>
  	  </table>";
  $txt .= $frm->form_close();

  return $txt;
}
?>
