<?php
/*
+---------------------------------------------------------------+
|       e107 website system imagegallery plugin
|       e107_plugins/imagegallery/browse.php
|
|        Mark Pustjens 2003
|       http://unkie.org
|       mark@unkie.org
|
|       Released under the terms and conditions of the
|       GNU General Public License (http://gnu.org).    
+---------------------------------------------------------------+
*/

require_once("../../class2.php");

@include("languages/imagegallery_".e_LANGUAGE.".php");
@include("languages/imagegallery_English.php");

/* some handy functions */
require_once("functions.php");

/*
 * get the vars
 */
list($category, $from, $images, $sortorder, $sortfield) = explode(".", e_QUERY);

$category = intval($category);
$from = intval($from);
$images = intval($images);
$sortorder = intval($sortorder);
$sortfield = strval($sortfield);
$imgsortfield = intval($sortfield[0]);
$catsortfield = intval($sortfield[1]);

/*
 * if a change of view was posted
 */
if (isset($_POST['changeview'])){
  $sortorder = strval($_POST['sortorder'] == "descending" ? "0" : "1");
  $imgsortfield = intval($_POST['imgsortfield']) ? intval($_POST['imgsortfield']) : $imgsortfield;
  $catsortfield = intval($_POST['catsortfield']) ? intval($_POST['catsortfield']) : $catsortfield;
  $images = intval($_POST['images']) ? intval($_POST['images']) : $images;
}

/*
 * check the vars
 */
if ($category <= 0) $category = 1;
if ($images <= 0) $images = $pref['ig_items_per_row'] * $pref['ig_rows_per_page'];
if ($imgsortfield < 0 || $imgsortfield > 2) $imgsortfield = 1;
if ($catsortfield < 0 || $catsortfield > 1) $catsortfield = 1;

/* check if the user is authorized to be here */
if(!is_authorized($category, "view")){
  header('location: '.SITEURL.$PLUGINS_DIRECTORY.'imagegallery/browse.php');
  exit;
}

/*
 * get the mode
 */
 $mode = get_default_mode($category, "all");

/* to parse some texts */
$tp = new textparse;

$cattxt = render_rows("cat", $mode, $category, $from, $images, $sortorder, $catsortfield);
$imgtxt = render_rows("img", $mode, $category, $from, $images, $sortorder, $imgsortfield);

/*
 * now display the page
 */
require_once(HEADERF);
if (USER && is_authorized($category, "admin")){
  $ns->tablerender(IG_033, render_admin($category));
}
if (is_authorized($category, "submit")){
  $ns->tablerender(IG_020, render_user($category));
}
$ns->tablerender(IG_133, $cattxt.$imgtxt);
require_once(FOOTERF);

/*******************************************************************/

function render_options_bar($url, $type, $category, $total, $from, $items, $sortorder, $sortfield){
  global $pref;
  require_once(e_HANDLER."form_handler.php");

  if ($type == "img" && $from > 0){
    $myfrom = $from - $items;
    if ($myfrom < 0) $myfrom = 0;
    $previous_items = '<a href="'.$url.'?'.$category.'.'.$myfrom.'.'.$items.'.'.$sortorder.'.'.$sortfield.'">&lt;&lt; '.IG_134.'</a>';
  } else {
    $previous_items = '&lt;&lt; '.IG_134;
  }

  if ($type == "img" && ($from + $items) < $total){
    $myfrom = $from + $items;
    $next_items = '<a href="'.$url.'?'.$category.'.'.$myfrom.'.'.$items.'.'.$sortorder.'.'.$sortfield.'">'.IG_135.' &gt;&gt;</a>';
  } else {
    $next_items = IG_135.' &gt;&gt;';
  }

  $frm = new form;
  $options = ' '.IG_136;

  if ($type == "img") {
    $options .= $frm->form_select_open("imgsortfield");
    $options .= $frm->form_option(IG_137,($sortfield == 0 ? 1 : 0),0);
    $options .= $frm->form_option(IG_138,($sortfield == 1 ? 1 : 0),1);
    $options .= $frm->form_option(IG_139,($sortfield == 2 ? 1 : 0),2);
    //$options .= $frm->form_option("rating",($sortfield == 3 ? 1 : 0),3);
    $options .= $frm->form_select_close();
  } else {
    $options .= $frm->form_select_open("catsortfield");
    $options .= $frm->form_option(IG_137,($sortfield == 0 ? 1 : 0),0);
    $options .= $frm->form_select_close();
  }

  $options .= ' '.IG_142;
  $options .= $frm->form_select_open("sortorder");
  $options .= $frm->form_option(IG_140,($sortorder == 0 ? 1 : 0),"descending");
  $options .= $frm->form_option(IG_141,($sortorder == 1 ? 1 : 0),"ascending");
  $options .= $frm->form_select_close();

  if ($type == "img") {
    $options .= ' '.IG_143;
    $options .= $frm->form_select_open("images");

    $n = $pref['ig_items_per_row'] * $pref['ig_rows_per_page'];
    for ($i=0; $i < 4;$i++){
      $options .= $frm->form_option($n,($items == $n ? 1 : 0),$n);
      $n *= 2;
    }
    $options .= $frm->form_select_close();
  }

  $options .= $frm->form_button("submit", "changeview", "change");

  $txt .= $frm->form_open("post", "$url?$category.$from.$items.$sortorder.$sortfield");
  $txt .= "<table style='width: 100%;'><tr>";
  if ($type == "img") {
    $txt .= "<td class='forumheader' style='text-align: left;'>$previous_items</td>
    <td class='forumheader' style='text-align: center;'>$options</td>
    <td class='forumheader' style='text-align: right;'>$next_items</td>";
  } else {
    $txt .= "<td class='forumheader' style='text-align: center;'>$options</td>";
  }
  $txt .= "</tr></table>";
  $txt .= $frm->form_close();

  return $txt;
}

function render_admin($category){
  return '<a href="admin_browse.php?'.$category.'">'.IG_144.'</a> -
  	  <a href="admin_batchadd.php?'.$category.'">'.IG_046.'</a> - 
	  <a href="admin_image.php?new.'.$category.'">'.IG_048.'</a> - 
	  <a href="admin_category.php?edit.'.$category.'">'.IG_145.'</a>';
}

function render_user($category){
  return '<a href="submit.php?submit.'.$category.'">'.IG_146.'</a>';
}

/* renders image browse view in row mode */
function render_rows($type, $mode, $category, $from, $items, $sortorder, $sortfield){
  global $pref;
  $sql = new DB;

  /******************/
  /** get the data **/
  /******************/

  if ($type == "img"){
    $ascdesc = $sortorder == 0 ? "DESC" : "ASC";
    $mysortfield = img_id_to_field($sortfield);
    $total = $sql->db_Count('images', '(*)', 'WHERE img_category='.$category);
    $count = $sql->db_Select("images", "img_id, img_name, img_description, img_author, img_thumb, img_category, img_datestamp, img_width, img_height", "img_category=$category ORDER BY img_$mysortfield $ascdesc LIMIT $from, $items");
    $header = '<strong>'.IG_147.'</strong>';
  } else {
    $ascdesc = $sortorder == 0 ? "DESC" : "ASC";
    $mysortfield = cat_id_to_field($sortfield);
    $total = $sql->db_Count('images_category', '(*)', 'WHERE category_category='.$category);
    $count = $sql->db_Select("images_category", "category_id, category_name, category_image, category_width, category_height, category_description, category_class_view", "category_category=$category ORDER BY category_$mysortfield $ascdesc");
    if ($category > 1) $count++;
    $header = '<strong>'.IG_148.'</strong>';
  }

  /**************************************************/
  /** if there are images/categories, do something **/
  /**************************************************/

  if ($count && $mode){

    /*
     * what are we rendering
     */
    if ($type == "img") {
      $mymode = $mode['img'];
    } else {
      $mymode = $mode['cat'];
    }

    unset($thumb);
 
    /*
     * make the options bar
     */
    $options = render_options_bar(e_SELF, $type, $category, $total, $from, $items, $sortorder, $sortfield);

    switch ($mymode){
      /***************************************/
      /** large thumbnail view without info **/
      /***************************************/
      case 5:
        $noinfo = true;
      /**************************/
      /** large thumbnail view **/
      /**************************/
      case 1:
        if (!isset($info)) $noinfo = false;
      	$txt .= "<div class='forumheader2'> $header </div>";
	$txt .= "<table style='width: 100%;'><tr><td colspan='".$pref['ig_items_per_row']."'>";
	$txt .= $options;
	$txt .= "</td></tr><tr>";

	$item = 0;
	$count += $count % $pref['ig_items_per_row'];
	$columnwidth = floor(100 / $pref['ig_items_per_row']);

	if ($type == "img" || $category == 1){
	  $i = 0;
	} else {
	  $txt .= "<td>";
	  $txt .= render_cat_parent($category);
	  $txt .= "</td>";
	  $i = 1;
	}

	for (; $i < $count; $i++){

	  $data = $sql->db_Fetch();

	  if ($type == "cat" && !check_class($data['category_class_view']) && !getperms('P')) continue;

	  if ($item >= $pref['ig_items_per_row']){
	    $txt .= "</tr><tr>";
	    $item = 0;
	  }

	  $txt .= "<td style='width: $columnwidth%; text-align: center'>";

	  if ($type == "img"){
	    $txt .= render_img($data, $mode['view'], $noinfo);
	  } else {
	    $txt .= render_cat($data);
	  }
	  
	  $txt .= "</td>";

	  $item++;
	}

	$txt .= "</tr><tr><td colspan='".$pref['ig_items_per_row']."'>";
	$txt .= $options;
	$txt .= "</td></tr></table>";
	break;

      /**************************/
      /** list with thumbnails **/
      /**************************/
      case 2:
      	$thumb = true;
      /*****************************/
      /** list without thumbnails **/
      /*****************************/
      case 3:
      	if (!isset($thumb)) $thumb = false;
      	$txt .= "<div class='forumheader2'> $header </div>";
	$txt .= "<table style='width: 100%;'><tr><td>";
	$txt .= $options;
	$txt .= "</td></tr>";

	if ($type == "img" || $category == 1){
	  $i = 0;
	} else {
	  $txt .= "<tr><td>";
	  $txt .= render_list_cat_parent($thumb, $category);
	  $txt .= "</td></tr>";
	  $i = 1;
	}

	for (; $i < $count; $i++){

	  $data = $sql->db_Fetch();

	  if ($type == "cat" && !check_class($data['category_class_view']) && !getperms('P')) continue;

	  $txt .= "<tr><td>";

	  if ($type == "img"){
	    $txt .= render_list_img($thumb, $data, $mode['view']);
	  } else {
	    $txt .= render_list_cat($thumb, $data);
	  }
	    
	  $txt .= "</td></tr>";
	}
      
	$txt .= "</table>";
	break;
      /***************************************/
      /** dropdown list ONLY for categories **/
      /***************************************/
      case 4:
	require_once(e_HANDLER."form_handler.php");
	$frm = new form;

	$sql2 = new DB;
	$sql2->db_Select("images_category", "category_category", "category_id=$category");
	list ($category_category) = $sql2->db_Fetch();
  
	$txt .= '<table style="width: 100%;"><tr><td class="forumheader2" style="width: 30%">'.IG_149.'</td><td class="forumheader2">';
	$txt .= '<select name="categoryjump" onChange="javascript: urljump(this.options[selectedIndex].value)" class="tbox">';
	$txt .= $frm->form_option(IG_151, 0, "");
	if ($category != 1) $txt .= $frm->form_option('Parent category', 0, "browse.php?$category_category");

	for ($i = 0; $i < $total; $i++){
	  extract($sql->db_Fetch());
	 
	  if (!check_class($category_class_view) && !getperms('P')) continue;
	 
	  $txt .= $frm->form_option($category_name, 0, "browse.php?$category_id");
	}

	$txt .= $frm->form_select_close();
	$txt .= $frm->form_button('button', 'go', IG_150, 'onClick="javascript: urljump(this.options[selectedIndex].value)"');
	$txt .= "</td></tr></table>";
	
        break;
    }

  /********************************************/
  /** return nothing if no images/categories **/
  /********************************************/

  } else {
    $txt = render_none($type, $category);
  }

  /* return our generated text */
  return $txt;
}


function render_none($type, $category){
  if ($type == "img")
    return '<div class="forumheader2">'.IG_152.'</div>';
  else {
    return '<div class="forumheader2">'.IG_153.'</div>';
  }
}

function render_img($imgdata, $viewmode, $noinfo){
  global $tp, $pref;
  $gen = new convert;
  extract($imgdata);

  $img_name = $tp->tpa($img_name);
  $img_description = $tp->tpa($img_description);
  $img_image = $tp->tpa($img_image);
  $img_author = $tp->tpa($img_author);
  list($img_width, $img_height) = calc_size($img_width, $img_height, $pref['ig_thumbnail_width'], $pref['ig_thumbnail_height']);

  list($author_id, $author_name) = explode('.', $img_author);
  $author_name = get_author_name($author_id, $author_name);

  if ($img_id) {
    $img_datestamp = $gen->convert_date($img_datestamp, "short");
    $img_thumb = get_img_url($img_thumb, $img_category);

    $txt = 
      "<table class='fborder' style='margin-bottom: 10px; padding: 3px;'>
         <tr>
	   <td style='width: ".$pref['ig_thumbnail_width']."px; height: ".$pref['ig_thumbnail_height']."px; vertical-align: middle; text-align: center; padding: 1px;'>
	     <a href='view.php?$img_id.$viewmode'><img style='border: 0;' src='$img_thumb' alt='$img_name' width='$img_width' height='$img_height' /></a>
	   </td>
	 </tr>";
    if (!$noinfo){
      $txt .= '<tr><td class="mediumtext">'.$img_name.'</td></tr>
       <tr><td class="smallblacktext">'.sprintf(IG_154, $author_name, $img_datestamp).'</td></tr>';
    }
    $txt .= "</table>";
  }
  
  return $txt;
}

function render_list_img($thumb, $imgdata, $viewmode){
  global $tp, $pref;
  $gen = new convert;
  extract($imgdata);

  $img_name = $tp->tpa($img_name);
  $img_description = $tp->tpa($img_description);
  $img_image = $tp->tpa($img_image);

  list($img_width, $img_height) = calc_size($img_width, $img_height, $pref['ig_list_thumbnail_width'], $pref['ig_list_thumbnail_height']);

  if ($img_id){
    if ($thumb) {
      $img_thumb = get_img_url($img_thumb, $img_category);

      $txt = "
      <table style='width: 100%;'>
	<tr>
	  <td class='forumheader2' rowspan='2' style='width: ".$pref['ig_list_thumbnail_width']."px; height: ".$pref['ig_list_thumbnail_height']."px; vertical-align: middle; text-align: center; padding: 1px;'><a href='view.php?$img_id.$viewmode'><img style='border: 0;' src='$img_thumb' alt='$img_name' width='$img_width' height='$img_height' /></a></td>
	  <td class='forumheader3'>$img_name</td>
	</tr>
	<tr>
	  <td class='forumheader3'>$img_description</td>
	</tr>
      </table>";
    } else {
      $txt = "
      <table style='width: 100%;'>
	<tr>
          <td class='forumheader3' style='width: 5%;'><a href='view.php?$img_id.$viewmode'>view</a></td>
	  <td class='forumheader3' style='width: 15%;'>$img_name</td>
	  <td class='forumheader3' style='width: 80%;'>$img_description</td>
	</tr>
      </table>";
    }
  }

  return $txt;
}

function render_cat($catdata){
  global $tp, $pref;
  extract($catdata);
  $category_image = get_img_url($category_image, 0);

  $category_name = $tp->tpa($category_name);
  $category_description = $tp->tpa($category_description);
  $category_image = $tp->tpa($category_image);
  list($category_width, $category_height) = calc_size($category_width, $category_height, $pref['ig_thumbnail_width'], $pref['ig_thumbnail_height']);

  if ($category_id) {
    $txt = "<table class='fborder'  style='margin-bottom: 10px; padding: 3px;'>
    <tr><td style='width: ".$pref['ig_thumbnail_width']."px; height: ".$pref['ig_thumbnail_height']."px; vertical-align: middle; text-align: center; padding: 1px;'><a href='browse.php?$category_id'><img style='border: 0;' src='$category_image' alt='$category_name' width='$category_width' height='$category_height' /></a></td></tr>
    <tr><td class='mediumtext'>$category_name</td></tr>
    <tr><td class='smallblacktext'>$category_description</td></tr>
    </table>";
  }
  
  return $txt;
}

function render_cat_parent($category){
  global $sql, $pref, $PLUGINS_DIRECTORY;
  $sql->db_Select("images_category", "category_category", "category_id=$category");
  list ($category_category) = $sql->db_Fetch();

  list($category_width, $category_height) = getimagesize(e_PLUGIN.'imagegallery/images/folder.png');
  list($category_width, $category_height) = calc_size($category_width, $category_height, $pref['ig_thumbnail_width'], $pref['ig_thumbnail_height']);

  $txt = "<table class='fborder' style='margin-bottom: 10px; padding: 3px;'>
  <tr><td  style='width: ".$pref['ig_thumbnail_width']."px; height: ".$pref['ig_thumbnail_height']."px; vertical-align: middle; text-align: center; padding: 1px;'><a href='browse.php?$category_category'><img style='border: 0;' src='/".$PLUGINS_DIRECTORY."imagegallery/images/folder.png' alt='...' width='$category_width' height='$category_height' /></a></td></tr>
  <tr><td class='mediumtext'> ... </td></tr>
  <tr><td class='smallblacktext'> ".IG_036." </td></tr>
  </table>";
  return $txt;
}

function render_list_cat($thumb, $catdata){
  global $tp, $pref;
  extract($catdata);

  $category_name = $tp->tpa($category_name);
  $category_description = $tp->tpa($category_description);
  $category_image = $tp->tpa($category_image);

  list($category_width, $category_height) = calc_size($category_width, $category_height, $pref['ig_list_thumbnail_width'], $pref['ig_list_thumbnail_height']);

  if ($category_id){
    if ($thumb) {
      $category_image = get_img_url($category_image, 0);
      $txt = "
      <table style='width: 100%;'>
	<tr>
	  <td class='forumheader2' rowspan='2' style='width: ".$pref['ig_list_thumbnail_width']."px; height: ".$pref['ig_list_thumbnail_height']."px; vertical-align: middle; text-align: center; padding: 1px;'><a href='browse.php?$category_id'>
	    <img style='border: 0;' src='$category_image' alt='$category_name' width='$category_width' height='$category_height' /></a>
	  </td>
	  <td class='forumheader3'>$category_name</td>
	</tr>
	<tr>
	  <td class='forumheader3'>$category_description</td>
	</tr>
      </table>";
    } else {
      $txt = '
      <table style="width: 100%;">
	<tr>
	  <td class="forumheader3" style="width: 5%;"><a href="browse.php?'.$category_id.'">'.IG_039.'</a></td>
	  <td class="forumheader3" style="width: 15%;">'.$category_name.'</td>
	  <td class="forumheader3" style="width: 80%;">'.$category_description.'</td>
	</tr>
      </table>';
    }
  }

  return $txt;
}

function render_list_cat_parent($thumb, $category){
  global $sql, $pref, $PLUGINS_DIRECTORY;
  $sql->db_Select("images_category", "category_category", "category_id=$category");
  list ($category_category) = $sql->db_Fetch();

  list($category_width, $category_height) = getimagesize(e_PLUGIN.'imagegallery/images/folder.png');
  list($category_width, $category_height) = calc_size($category_width, $category_height, $pref['ig_list_thumbnail_width'], $pref['ig_list_thumbnail_height']);

  if ($thumb) {
    $txt = '
    <table style="width: 100%;">
      <tr>
	<td class="forumheader2" rowspan="2" style="width: '.$pref['ig_list_thumbnail_width'].'px; height: '.$pref['ig_list_thumbnail_height'].'px; vertical-align: middle; text-align: center; padding: 1px;"><a href="browse.php?'.$category_category.'">
	  <img style="border: 0;" src="'.$PLUGINS_DIRECTORY.'imagegallery/images/folder.png" alt="..." width="'.$category_width.'" height="'.$category_height.'" /></a>
	</td>
	<td class="forumheader3">...</td>
      </tr>
      <tr>
	<td class="forumheader3">'.IG_036.'</td>
      </tr>
    </table>';
  } else {
    $txt = '
    <table style="width: 100%;">
      <tr>
	<td class="forumheader3" style="width: 5%;"><a href="browse.php?'.$category_category.'">view</a></td>
	<td class="forumheader3" style="width: 15%;">...</td>
	<td class="forumheader3" style="width: 80%;">'.IG_036.'</td>
      </tr>
    </table>';
  }
  return $txt;
}
?>
