<?php
/*
+---------------------------------------------------------------+
|       e107 website system imagegallery plugin
|       e107_plugins/imagegallery/functions.php
|
|        Mark Pustjens 2003
|       http://unkie.org
|       mark@unkie.org
|
|       Released under the terms and conditions of the
|       GNU General Public License (http://gnu.org).    
+---------------------------------------------------------------+
*/

/* get a list of the images in a folder
 */
function get_images($folder) {
  $dir = opendir(e_FILE . "imagegallery/" . $folder);
  $list = array();

  while(false !== ($file = readdir($dir))){
    if (is_dir($folder.$file) || ($folder == 'category_thumbs/' && $file == 'folder.png')){
      /* do nothing */
    } elseif ($file != "." && $file != ".." && is_image(e_FILE."imagegallery/".$folder.$file)){
      /* add to the list */
      $list[] = $file;
    }
  }
  closedir($dir);

  /* sort the list */
  natcasesort($list);

  return $list;
}

function get_author_name($user_id, $user_name){
  global $sql;
  if (!$user_id) return $user_name;

  if ($sql->db_Select('user', 'user_name', 'user_id='.$user_id,true)){
    list($user_name) = $sql->db_Fetch();
    return $user_name;
  } else {
    return IG_155;
  }
}

function is_image($file){
  $image_stats = @getimagesize($file);
  if($image_stats == null) return false;
  return true;
}

function calc_size($org_width, $org_height, $new_width, $new_height){
  $width = $new_width;
  $height = $new_height;

  if ($org_width < $new_width && $org_height < $new_height) {
    $width = $org_width;
    $height = $org_height;
  }

  $width_ratio = $org_width / $new_width;
  $height_ratio = $org_height / $new_height;

  if ($org_width > $new_width || $org_height > $new_height){
    if ($width_ratio > $height_ratio){
      $width = $new_width;
      $height = $org_height / $width_ratio;
    } else {
      $width = $org_width / $height_ratio;
      $height = $new_height;
    }
  }

  $width = round($width);
  $height = round($height);

  return array($width, $height);
}

/* make the get_image_size output human readable */
function parseimagedetails($image){
  $types = array(1 => "GIF",
  		 2 => "JPG",
		 3 => "PNG",
		 4 => "SWF",
		 5 => "PSD",
		 6 => "BMP",
		 7 => "TIFF(intel byte order)",
		 8 => "TIFF(motorola byte order)",
		 9 => "JPC",
		 10 => "JP2",
		 11 => "JPX",
		 12 => "JB2",
		 13 => "SWC",
		 14 => "IFF",
		 15 => "WBMP",
		 16 => "XBM");
  list($width, $height, $type, $attr) = getimagesize($image);

  $str = $width."x".$height.", ".$types[$type];
  return $str;
}

function mode_category_list($form_name, $mode){
  require_once(e_HANDLER."form_handler.php");
  $frm = new form;

  $txt = $frm->form_select_open($form_name);
  $txt .= $frm->form_option(IG_156, $mode == '0', '0');
  $txt .= $frm->form_option(IG_157, $mode == '1', '1');
  $txt .= $frm->form_option(IG_158, $mode == '2', '2');
  $txt .= $frm->form_option(IG_159, $mode == '3', '3');
  $txt .= $frm->form_option(IG_160, $mode == '4', '4');
  $txt .= $frm->form_select_close();

  return $txt;
}

function mode_image_list($form_name, $mode){
  require_once(e_HANDLER."form_handler.php");
  $frm = new form;

  $txt = $frm->form_select_open($form_name);
  $txt .= $frm->form_option(IG_161, $mode == '0', '0');
  $txt .= $frm->form_option(IG_162, $mode == '1', '1');
  $txt .= $frm->form_option(IG_163, $mode == '5', '5');
  $txt .= $frm->form_option(IG_164, $mode == '2', '2');
  $txt .= $frm->form_option(IG_165, $mode == '3', '3');
  $txt .= $frm->form_select_close();

  return $txt;
}

function mode_view_list($form_name, $mode){
  require_once(e_HANDLER."form_handler.php");
  $frm = new form;

  $txt = $frm->form_select_open($form_name);
  $txt .= $frm->form_option(IG_166, $mode == '1', '1');
  $txt .= $frm->form_option(IG_167, $mode == '2', '2');
  //$txt .= $frm->form_option('As the above, but in a popup ', $mode == '7', '7');
  $txt .= $frm->form_option(IG_168, $mode == '3', '3');
  $txt .= $frm->form_option(IG_169, $mode == '4', '4');
  $txt .= $frm->form_option(IG_170, $mode == '5', '5');
  $txt .= $frm->form_option(IG_171, $mode['view'] == '6', '6');
  $txt .= $frm->form_select_close();

  return $txt;
}

/* create and image url for an image */
function get_img_url($img_name, $img_category){
  global $FILES_DIRECTORY;
  $sql = new DB;

  if ($img_category == 0){
    $img_path = $FILES_DIRECTORY."imagegallery/category_thumbs/$img_name";
    if ($img_name != "" && file_exists(e_BASE.$img_path)){
      return e_HTTP.$img_path;
    } else {
      return e_HTTP.$PLUGINS_DIRECTORY."imagegallery/images/no_image.png";
    }
  }
  
  if ($sql->db_Select("images_category", "category_name", "category_id=$img_category")){
    list($category_name) = $sql->db_Fetch();
    $img_path = e_FILE."imagegallery/$img_category-$category_name/$img_name";
    $img_path = $FILES_DIRECTORY."imagegallery/$img_category-$category_name/$img_name";

    if (file_exists(e_BASE.$img_path)) return e_HTTP.$img_path;
  }

  return e_HTTP.$PLUGINS_DIRECTORY."imagegallery/images/no_image.png";
}

/* create and image path for an image */
function get_img_path($img_name, $img_category, $check_exists){
  $sql = new DB;

  if ($img_category == 0){
    $img_path = e_FILE."imagegallery/category_thumbs/$img_name";
    if ($img_name != "" && file_exists(e_BASE.$img_path)){
      return e_BASE.$img_path;
    } else {
      return e_BASE.$PLUGINS_DIRECTORY."imagegallery/images/no_image.png";
    }
  }
  
  if ($sql->db_Select("images_category", "category_name", "category_id=$img_category")){
    list($category_name) = $sql->db_Fetch();
    $img_path = e_FILE."imagegallery/$img_category-$category_name/$img_name";

    if ($check_exists) {
      if (file_exists($img_path)) return $img_path;
    } else {
      return $img_path;
    }
  }

  return e_BASE.$PLUGINS_DIRECTORY."imagegallery/images/no_image.png";
}

/* check if the user is authorized */
function is_authorized($category_id, $type = "all"){
  global $sql;
  $sql->db_Select("images_category", "category_class_view, category_class_submit, category_class_admin", "category_id=$category_id");
  list($class_view, $class_submit, $class_admin) = $sql->db_Fetch();
  switch ($type){
    case "view": return check_class($class_view) || getperms('P');
    case "submit": return check_class($class_submit) || getperms('P');
    case "admin": return check_class($class_admin || getperms('P'));
    case "all":
    default: return array("view" => check_class($class_view) || getperms('P'),
    			  "submit" => check_class($class_submit) || getperms('P'),
			  "admin" => check_class($class_admin) || getperms('P'));
  }
  return check_class($category_class);
}

/* retreive the default mode */
function get_default_mode($category_id, $what = "all"){
  $sql = new DB;
  $sql->db_Select("images_category", "category_mode", "category_id=$category_id");
  list($mode) = $sql->db_Fetch();
  list($view_mode, $img_mode, $cat_mode) = explode(".", $mode);
  switch ($what){
    case "view": return $view_mode;
    case "img": return $img_mode;
    case "cat": return $cat_mode;
    case "all":
    default: return array("view" => $view_mode, "img" => $img_mode, "cat" => $cat_mode);
  }
}

function get_default_perms($category_id, $what = "all"){
  $sql = new DB;
  $sql->db_Select("images_category", "category_class_view, category_class_submit, category_class_admin", "category_id=$category_id");
  extract($sql->db_Fetch());
  switch ($what){
    case "view": return $category_class_view;
    case "submit": return $category_class_submit;
    case "admin": return $category_class_admin;
    case "all":
    default: return array("view" => $category_class_view, "submit" => $category_class_submit, "admin" => $category_class_admin);
  }
}

function img_id_to_field($id){
  switch ($id){
    case 0  : return "name";
    case 1  : return "datestamp";
    case 2  : return "views";
    case 3  : return "rating";
    default : return "name";
  }
}

function img_field_to_id($field){
  switch ($field){
    case "name"  : return 0;
    case "date"  : return 1;
    case "views" : return 2;
    case "rating": return 3;
    default: return 0;
  }
}

function cat_id_to_field($id){
  switch ($id){
    case 0  : return "name";
    case 1  : return "views";
    case 2  : return "rating";
    default : return "name";
  }
}

function cat_field_to_id($field){
  switch ($field){
    case "name"  : return 0;
    case "views" : return 1;
    case "rating": return 2;
    default: return 0;
  }
}

function my_htmlentities($string){
  $string = htmlentities($string, ENT_QUOTES);
  $string = preg_replace("/(&#)0+(\d+)(;)/", '\1\2\3', $string);

  return $string;
}

function check_no_quotes($string){
  if (strpos($string, "'") === false && strpos($string, '"') === false){
    return true;
  } else {
    return false;
  }
}

?>
