<?php
/*
+---------------------------------------------------------------+
|       e107 website system
|       e107_plugins/imagegallery/plugin.php
|
|        Mark Pustjens 2003
|       http://unkie.org
|       mark@unkie.org
|
|       Released under the terms and conditions of the
|       GNU General Public License (http://gnu.org).    
+---------------------------------------------------------------+
*/

// language files
@include("languages/imagegallery_".e_LANGUAGE.".php");
@include("languages/imagegallery_English.php");

// Plugin info 
$eplug_name = "imagegallery";
$eplug_version = "3.0pre1";
$eplug_author = "unknown";
$eplug_logo = "button.png";
$eplug_url = "http://unkie.org";
$eplug_email = "mark@unkie.org";
$eplug_description = "A basic image gallery.";
$eplug_compatible = "e107v6";
$eplug_readme = "";

// Name of the plugin's folder 
$eplug_folder = "imagegallery";
// Name of the plugin menu item. 
//$eplug_menu_name = "imagegallery";

$eplug_icon = $eplug_folder."/images/imagegallery_icon.png";


// Name of the admin configuration file 
$eplug_conffile = "admin_main.php";

// Icon image and caption text 
// this info will be displayed in the admin  panel. 
//$eplug_icon = $eplug_folder."imagesyour_icon.png";
$eplug_caption = "Image Gallery";

// List of preferences 
// creates a setting in the core preferences. - in this example the value 0 is  retrieved using $pref['eventpost_admin'] ( replace eventpost_admin with your unique name ) 
$eplug_prefs = array(
	'ig_items_per_row' => 3,
	'ig_rows_per_page' => 4,
	'ig_thumbnail_width' => 180,
	'ig_thumbnail_height' => 144,
	'ig_folder_perms' => '0777',
	'ig_list_thumbnail_width' => 90,
	'ig_list_thumbnail_height' => 72,
	'ig_folder_perms' => '0777',
	'ig_file_perms' => '0666',
	'ig_max_submit' => 10
		   );

// table names and definitions
$eplug_table_names = array("images_category", "images");
$eplug_tables = array(	"CREATE TABLE ".MPREFIX."images_category (
				category_id		int(10)		unsigned	NOT NULL auto_increment,
                                category_name		varchar(100)			NOT NULL default '',
                                category_description	text				NOT NULL,
                                category_image		varchar(150)			NOT NULL default '',
				category_width		int(10)		unsigned	NOT NULL default '0',
				category_height		int(10)		unsigned	NOT NULL default '0',
				category_category	int(10)		unsigned	NOT NULL default '0',
				category_class_view	tinyint(3)	unsigned	NOT NULL default '0',
				category_class_submit	tinyint(3)	unsigned	NOT NULL default '255',
				category_class_admin	tinyint(3)	unsigned	NOT NULL default '254',
				category_mode		varchar(5)			NOT NULL default '1.1.2',
				category_allow_comments	tinyint(3)	unsigned 	NOT NULL default '0',
				PRIMARY KEY  (category_id)
			) TYPE=MyISAM;",

			"CREATE TABLE ".MPREFIX."images (
				img_id			int(10)		unsigned	NOT NULL auto_increment,
				img_name		varchar(100) 			NOT NULL default '',
				img_description 	text 				NOT NULL,
				img_thumb		varchar(150)			NOT NULL default '',
				img_image		varchar(150)			NOT NULL default '',
				img_datestamp		int(10) 	unsigned	NOT NULL default '0',
				img_category		int(10) 	unsigned	NOT NULL default '1',
				img_author		varchar(100)			NOT NULL default '',
				img_author_email	varchar(200)			NOT NULL default '',
				img_author_homepage	varchar(200)			NOT NULL default '',
				img_views		int(10) 	unsigned 	NOT NULL default '0',
				img_width		int(10)		unsigned	NOT NULL default '0',
				img_height		int(10)		unsigned	NOT NULL default '0',
				PRIMARY KEY (img_id)
			) TYPE=MyISAM;",

			"INSERT INTO ".MPREFIX."images_category (category_id, category_name, category_description, category_class_view, category_class_submit, category_class_admin, category_image, category_width, category_height) VALUES ( 1, 'root_category', 'This is the root category, all other categorys are children of this one', 0, 253, 254, 'folder.png', 70, 69);"
		);

// Create a link in main menu (yes=TRUE, no=FALSE) 
$eplug_link = TRUE;
$eplug_link_name = "Image Gallery";
$eplug_link_url = e_PLUGIN."imagegallery/browse.php";

// Text to display after plugin successfully installed 
$eplug_done = "Image Gallery database was succesfully installed. Now continue to the admin section of this plugin to continue setup.";

// add this preference when upgrading

$upgrade_add_prefs = "";
//$upgrade_add_prefs = array("ig_thumbsize" => 200);

$upgrade_remove_prefs = "";

$upgrade_alter_tables = "";

$eplug_upgrade_done = "";
//$eplug_upgrade_done = "Image Gallery has been successfully upgraded to version ".$eplug_version;

?>
