<?php
/*
+---------------------------------------------------------------+
|	e107 website system
|	e107_plugins/imagegallery/resizer.php
|	origional: resize_handler.php
|
|	Steve Dunstan 2001-2002
|	http://e107.org
|	jalist@e107.org
|	Mark Pustjens 2004
|	http://unkie.org
|	mark@unkie.org
|
|	Released under the terms and conditions of the
|	GNU General Public License (http://gnu.org).
|
+---------------------------------------------------------------+
*/

function resize_image($source_file, $destination_file, $new_width, $new_height){
	global $pref;

	require_once('functions.php');

	$mode = ($pref['resize_method'] ? $pref['resize_method'] : "gd2");
	$quality = ($pref['im_quality'] ? $pref['im_quality'] : 99);

	$image_stats = getimagesize($source_file);

	if ($image_stats[2] != 1 && $image_stats[2] != 2 && $image_stats[2] != 3 && ($mode == 'gd1' || $mode == 'gd2')){
		echo "<b>DEBUG</b> Wrong image type<br />";
		return FALSE;
	}

	$org_width = $image_stats[0];
	$org_height = $image_stats[1];

	list($width, $height) = calc_size($org_width, $org_height, $new_width, $new_height);
	
	switch ($mode){
	case "ImageMagick":
		$source_file = addslashes($source_file);
		$destination_file = addslashes($destination_file);
		if ($destination_file == "stdout") {
			/* if destination is stdout, output directly to the browser */
			$destination_file = "jpg:-";
			header("Content-type: image");
			passthru ($pref['im_path']."convert -quality ".$quality." -antialias -geometry ".$width."x".$height." '".$source_file."' '".$destination_file."'");
		}else{
			/* otherwise output to file */
			exec ($pref['im_path']."convert -quality ".$quality." -antialias -geometry ".$width."x".$height." '".$source_file."' '".$destination_file."'");
		}
		break;
		
	case "gd1":
		if($image_stats[2] == 2){
			$src_img = imagecreatefromjpeg($source_file);
		} else {
			$src_img = imagecreatefrompng($source_file);
		}
		if(!$src_img){
			return FALSE;
		}
		$dst_img = imagecreate($width, $height);
		imagecopyresized($dst_img, $src_img, 0, 0, 0, 0, $width, $height, $org_width, $org_height);

		if($destination_file == "stdout"){
			header("Content-type: image");
			imagejpeg($dst_img, '', $quality);
		} else {
			imagejpeg($dst_img, $destination_file, $quality);
			imagedestroy($src_img);
			imagedestroy($dst_img);
		}
		break;
		
	case "gd2":
		if ($image_stats[2] == 2){
			$src_img = imagecreatefromjpeg($source_file);
		} else {
			$src_img = imagecreatefrompng($source_file);
		}
		if (!$src_img){
			return FALSE;
		}

		$dst_img = imagecreatetruecolor($width, $height);
		imagecopyresampled($dst_img, $src_img, 0, 0, 0, 0, $width, $height, $org_width, $org_height);

		if ($destination_file == "stdout"){
			header("Content-type: image");
			imagejpeg($dst_img, '', $quality);
		} else {
			imagejpeg($dst_img, $destination_file, $quality);
			imagedestroy($src_img);
			imagedestroy($dst_img);
		}
		break;
	}

	@chmod($destination_file, 0644);
	if($pref['image_owner']){
		@chown($destination_file, $pref['image_owner']);
	}

	$image_stats = getimagesize($destination_file);
	if($image_stats == null){
		return false;
	}else{
		return true;
	}
}
?>
