<?php
/*
+---------------------------------------------------------------+
|       e107 website system imagegallery plugin
|       e107_plugins/imagegallery/submit.php
|
|        Mark Pustjens 2003
|       http://unkie.org
|       mark@unkie.org
|
|       Released under the terms and conditions of the
|       GNU General Public License (http://gnu.org).    
+---------------------------------------------------------------+
*/

require_once("../../class2.php");

@include("languages/imagegallery_".e_LANGUAGE.".php");
@include("languages/imagegallery_English.php");

/* some handy functions */
require_once("functions.php");

/* check authorisation */
list($mode, $item) = explode(".", e_QUERY);
$item = intval($item);
$mode = strval($mode);
if(!$item || ($mode != 'submit' && $mode != 'approve') || ($mode == 'submit' && !is_authorized($item, "submit")) || ($mode == 'approve' && !getperms('P'))){
  header('location:'.SITEURL.'index.php'); 
  exit;
}

/* get some vars */
$img = $_POST['img'];
foreach($img as $key => $val) $img[$key] = strval($val);
if ($mode == 'submit'){
  $img['img_category'] = $item;
} else {
  $img['img_category'] = 0;
  $img['img_id'] = $item;
}

/* if cancel was pushed, return */
if (isset($_POST['cancel'])){
  if ($mode == 'submit'){
    header('location: '.SITEURL.$PLUGINS_DIRECTORY.'imagegallery/browse.php?'.$item);
  } else {
    header('location: '.SITEURL.$PLUGINS_DIRECTORY.'imagegallery/admin_browse.php');
  }
}

switch ($mode){
  case 'submit':
    if ($sql->db_Count('images', '(*)', 'WHERE img_category=0') >= $pref['ig_max_submit']){
      $page_txt = render_message();
      break;
    }
    /* if submit was clicked, try to add the image */
    switch (isset($_POST['submit'])){
      case true:
	list($img, $msg) = get_defaults($img);
	$msg = add_img($img);
	if ($msg === true){
	  $page_txt = render_success($mode, $item);
	  break;
	}
      case false:
      default:
	$page_txt = render_page($mode, $img);
	break;
    }
    break;
  case 'approve':
    switch (isset($_POST['approve'])){
      case true:
        $img['img_author'] = '0.'.$img['img_author'];
  	$newpath = get_img_path("", $img['img_views'], "false");;
        if (approve_img($img)){
	  $page_txt = render_success($mode, $item);
          break;
	}
      case false:
	default:
	$sql->db_Select('images', '*', 'img_id='.$item);
	$img = $sql->db_Fetch();
        list($dummy, $img['img_author']) = explode('.', $img['img_author']);
        $page_txt = render_page($mode, $img);
        break;
    }
    break;
}

require_once(HEADERF);
if ($msg !== true) $ns->tablerender(IG_172, $msg);
$ns->tablerender(IG_173, $page_txt);
require_once(FOOTERF);

/*********************************************************************/

function render_success($mode, $item){
  require_once(e_HANDLER."form_handler.php");
  $frm = new form;

  $txt = $frm->form_open("post", e_SELF."?".e_QUERY);
  if ($mode == 'submit'){
    $txt .= IG_174;
  } else {
    $txt .= IG_175;
  }
  $txt .= '<div style="text-align: center"><br />';
  $txt .= $frm->form_button("submit", "cancel", IG_019);
  $txt .= '</div>';
  $txt .= $frm->form_close();

  return $txt;
}

function render_page($mode, $img){
  return render_form($mode, $img);
}

function render_message(){
  require_once(e_HANDLER."form_handler.php");
  $frm = new form;

  $txt = $frm->form_open("post", e_SELF."?".e_QUERY);
  $txt .= IG_176;
  $txt .= '<div style="text-align: center"><br />';
  $txt .= $frm->form_button("submit", "cancel", IG_019);
  $txt .= '</div>';
  $txt .= $frm->form_close();

  return $txt;
}

/* sets defaults for the image */
function get_defaults($img){
  /* to parse some texts */
  $tp = new textparse;

  /* find out what image was uploaded, if any */
  if (isset($_FILES['file_userfile'])){
    require_once(e_HANDLER."upload_handler.php");

    ob_start();
    $uploaded = file_upload(e_FILE."imagegallery/0-submitted_images/", true);
    $msg = ob_get_contents();
    ob_end_clean();

    if ($uploaded) {
      $img['path'] = "0-submitted_images/";
     
      $img['img_image'] = $uploaded[0]["name"];
      $img['img_thumb'] = preg_replace('/(.+)(\.[a-z]{3})/i', '\1_thumb\2', $img['img_image']);
    }
  }

  $img['img_name'] = $tp->formtpa($img['img_name']);
  $img['img_description'] = $tp->formtpa($img['img_description']);

  return array($img, $msg);
}

/* add a new image */
function add_img($img){
  global $sql, $pref;
  require_once("resizer.php");

  if (!isset($img['img_image']) || !check_no_quotes($img['img_image'])) return IG_177;

  if ($sql->db_Count("images", "(*)", "WHERE img_category=0 AND img_image='".$img['img_image']."'", true, true)) return IG_178;

  if (!resize_image(e_FILE."imagegallery/".$img['path'].$img['img_image'], e_FILE."imagegallery/".$img['path'].$img['img_thumb'], $pref['ig_thumbnail_width'], $pref['ig_thumbnail_height'])) return IG_116;

  list($img['width'], $img['height']) = getimagesize(e_FILE."imagegallery/".$img['path'].$img['img_image']);
      
  /* insert in db. desired category is saved in the views column */
  if (!$sql->db_Insert("images",
  			"0,
			'".$img['img_name']."',
			'".$img['img_description']."',
			'".$img['img_thumb']."',
			'".$img['img_image']."',
			".time().",
			0,
			'0.".$img['img_author']."',
			'".$img['img_author_email']."',
			'".$img['img_author_homepage']."',
			".$img['img_category'].",
			".$img['width'].",
			".$img['height'])){
    /* undo if something fails */
    unlink( e_FILE."imagegallery/".$image['newpath'].$image['img_thumb']);
    return IG_177;
  }

  return true;
}

function approve_img($img){
  global $sql;

  /* first update the database */
  if (!$sql->db_Update('images',
  		       'img_name="'.$img['img_name'].'",
  		       img_description="'.$img['img_description'].'",
  		       img_author="'.$img['img_author'].'",
  		       img_author_email="'.$img['img_author_email'].'",
  		       img_author_homepage="'.$img['img_author_homepage'].'",
  		       img_views=0,
		       img_category='.$img['img_views'].'
		       WHERE img_id='.$img['img_id'])){
    return false;
  }

  $newpath = get_img_path("", $img['img_views'], "false");;
  /* move the image and thumbnail image */
  if (!rename(e_FILE.'imagegallery/0-submitted_images/'.$img['img_image'], e_FILE.'imagegallery/'.$newpath.'/'.$img['img_image'])) return false;

  if (!rename(e_FILE.'imagegallery/0-submitted_images/'.$img['img_thumb'], e_FILE.'imagegallery/'.$newpath.'/'.$img['img_thumb'])){
    rename(e_FILE.'imagegallery/'.$newpath.'/'.$img['img_image'], e_FILE.'imagegallery/0-submitted_images/'.$img['img_image']);
    return false;
  }

  return true;
}

/* render the submit form */
function render_form($mode, $img){
  require_once(e_HANDLER."form_handler.php");
  $frm = new form;
  $tp = new textparse;

  $txt = $frm->form_open("post", e_SELF."?".e_QUERY, "", "", " enctype='multipart/form-data'");
  $txt .= '<table style="width: 95%;" class="fborder">
  	    <tr><td class="forumheader" colspan="2">'.IG_055.'</td></tr>';
  if ($mode == 'submit'){
    $txt .=  '<tr>
		<td class="forumheader3">'.IG_118.'</td>
		<td class="forumheader3">';
    $txt .= $frm->form_file('file_userfile[]', 40);
    $txt .=  "</td>
	    </tr>";
  }
  $txt .='<tr>
	    <td class="forumheader3">'.IG_056.'</td>
	    <td class="forumheader3">';
  $txt .= $frm->form_text("img[img_name]", 35, $tp->formtpa($img['img_name'], 100));
  $txt .=    '</td>
  	    </tr>
  	    <tr>
	      <td class="forumheader3">'.IG_057.'</td>
	      <td class="forumheader3">';
  $txt .= $frm->form_textarea("img[img_description]", 50, 4, $tp->formtpa($img['img_description']));
  $txt .=    "</td>
  	    </tr>";
  if ($mode == 'submit'){
    $txt .= '<tr><td class="forumheader" colspan="2">'.IG_179.'</td></tr>';
  } else {
    $txt .= '<tr><td class="forumheader" colspan="2">'.IG_180.'</td></tr>';
  }
  $txt .=  '<tr>
	      <td class="forumheader3">
	        '.IG_056.'<br />
		<span class="smalltext">'.IG_181.'</span>
	      </td>
	      <td class="forumheader3">';
  $txt .= $frm->form_text("img[img_author]", 35, $tp->formtpa($img['img_author'], 100));
  $txt .=    '</td>
  	    <tr>
	      <td class="forumheader3">'.IG_182.'</td>
	      <td class="forumheader3">';
  $txt .= $frm->form_text("img[img_author_email]", 35, $tp->formtpa($img['img_author_email'], 200));
  $txt .=    '</td>
  	    <tr>
	      <td class="forumheader3">'.IG_183.'</td>
	      <td class="forumheader3">';
  $txt .= $frm->form_text("img[img_author_homepage]", 35, $tp->formtpa($img['img_author_homepage'], 200));
  $txt .=    "</td>";
  if ($mode == 'submit'){
    $txt .= '<tr><td class="forumheader" colspan="2">'.IG_184.'</td></tr>';
  } else {
    $txt .= '<tr><td class="forumheader" colspan="2">'.IG_185.'</td></tr>';
  }
  $txt .=  "<tr>
	      <td colspan='2' style='text-align: center;' class='forumheader3'>";
  if ($mode == 'submit'){
    $txt .= $frm->form_button("submit", "submit", IG_071);
  } else {
    $txt .= $frm->form_button("submit", "approve", IG_186);
    $txt .= $frm->form_button("button", "delete", IG_102, "onClick=\"javascript: document.location='admin_del.php?0.".$img['img_id']."'\"");
    $txt .= $frm->form_button("submit", "cancel", IG_072);
    $txt .= $frm->form_hidden('img[img_image]', $img['img_image']);
    $txt .= $frm->form_hidden('img[img_thumb]', $img['img_thumb']);
    $txt .= $frm->form_hidden('img[img_views]', $img['img_views']);
  }
  $txt .=    "</td>
	    </tr>
  	  </table>";
  $txt .= $frm->form_close();

  return $txt;
}
?>
