<?php
/*
+---------------------------------------------------------------+
|       e107 website system imagegallery plugin
|       e107_plugins/imagegallery/view.php
|
|        Mark Pustjens 2003
|       http://unkie.org
|       mark@unkie.org
|
|       Released under the terms and conditions of the
|       GNU General Public License (http://gnu.org).    
+---------------------------------------------------------------+
*/

require_once("../../class2.php");

@include("languages/imagegallery_".e_LANGUAGE.".php");
@include("languages/imagegallery_English.php");

require_once(e_HANDLER."/comment_class.php");
require_once(e_HANDLER."/form_handler.php");

/*************************************************/
/** get the e_QUERY vars and make some defaults **/
/*************************************************/
list($img_id, $mode) = explode(".", e_QUERY);
$img_id = intval($img_id);
$mode = intval($mode);

render_page($img_id, $mode);
if (!$mode) $mode = 1;

/*********************/
/** render the page **/
/*********************/
function render_page($img_id, $mode){
  global $ns;
  $sql = new DB;
  $cobj = new comment;

  require_once("functions.php");

  /************************/
  /** get the image data **/
  /************************/
  if ($mode <= 3){
    $what = "img_id, img_name, img_description, img_thumb, img_image, img_datestamp, img_category, img_author, img_author_email, img_author_homepage, img_views";
  } else {
    $what = "img_id, img_name, img_category, img_image";
  }
  $count = $sql->db_Select("images", $what, "img_id=$img_id");

  /********************************************************/
  /** if the mode was not given use the category default **/
  /********************************************************/
  if ($mode == 0){
    $mode = intval(get_default_mode($img_category, "img"));
  }

  /************************************/
  /* if we have an image to work with */
  /************************************/
  if ($count && $mode){

    require_once(e_HANDLER."rate_class.php");

    /**************************************/
    /** extract the data for ease of use **/
    /**************************************/
    $row = $sql->db_Fetch();

    /*************************************/
    /** check if the user is authorized **/
    /*************************************/
    if (is_authorized($row['img_category'], "view")){
  
      /* see if a comment was posted */
      if(isset($_POST['commentsubmit'])){
	$cobj->enter_comment($_POST['author_name'], $_POST['comment'], "imgal", $img_id, intval($_POST['pid'], $_POST['subject']));
      }

      /**********************************/
      /** get the image submitter date **/
      /**********************************/
      if ($mode <= 3){
        $user = explode('.', $row['img_author']);
	if (!$user[0]) {
	  $row['img_author'] = $user[1];
	  $row['img_author_member'] = false;
	} else {
          $sql->db_Select("user", "user_name, user_email, user_homepage, user_id", "user_id='".$user[0]."'");
          $user = $sql->db_Fetch();
	  $row['img_author']          = $user['user_name'];
	  $row['img_author_email' ]   = $user['user_email'];
	  $row['img_author_homepage'] = $user['user_homepage'];
	  $row['img_author_member']   = $user['user_id'];
	}
      }
  
      switch ($mode){
	
	/**************/
	/** detailed **/
	/**************/
	case 1:
	  render_detailed("normal", $row);
	  break;

	/******************************************/
	/** detailed view with prev/next buttons **/
	/******************************************/
	case 2:
	  render_detailed("browse", $row);
	  break;
	  
	/***************************/
	/** technical information **/
	/***************************/
	case 3:
	  render_detailed("tech", $row);
	  break;

	/************************/
	/** only image in page **/
	/************************/
	case 4:
	  render_basic("page", $row['img_name'], $row['img_category'], $row['img_image'], $row['img_id']);
	  break;

	/*************************/
	/** only image in frame **/
	/*************************/
	case 5:
	  render_basic("frame", $row['img_name'], $row['img_category'], $row['img_image'], $row['img_id']);
	  break;
	
	/****************/
	/** only image **/
	/****************/
	case 6:
	  render_basic("bare", $row['img_name'], $row['img_category'], $row['img_image'], $row['img_id']);
	  break;

	/***************************************************/
	/** detailed view with prev/next buttons as popup **/
	/***************************************************/
	case 7:
	  render_detailed("popup", $row);
	  break;
      }

    } else {
      /*********************************************/
      /** user is not authorized, so tell him/her **/
      /*********************************************/
      global $HEADER, $FOOTER;
      require_once(HEADERF);
      $ns->tablerender(IG_187, IG_188);
      require_once(FOOTERF);
    }

  } else {
    global $PLUGINS_DIRECTORY;
    header('Location: '.SITEURL.$PLUGINS_DIRECTORY.'imagegallery/browse.php');
    exit;
  }

}

/**********************************************/
/* renders image in a very basic display mode */
/**********************************************/
function render_basic($type = "bare", $img_name, $img_category, $img_image, $img_id){
  global $ns;
  $img_url = get_img_url($img_image, $img_category);
  switch ($type){
    /***************************************/ 
    /** bare: redirect to the image alone **/ 
    /***************************************/ 
    case "bare":
      header("Location: $img_url");
      exit;

    /***********************************************************/
    /** the image on a page in the site, but without any info **/
    /***********************************************************/
    case "page":
      global $HEADER, $FOOTER, $sql;
      require(HEADERF);
      if (USER && is_authorized($img_category, "admin")){
        $ns->tablerender("Admin options", render_admin($img_category, $img_id));
      }
      $ns->tablerender($img_name, "<div style='text-align: ceter;'><img style='border: 0px;' src='$img_url' alt='$img_name' />");
      require(FOOTERF);
      break;

    /***********************************************/
    /** the image on its own page with basic info **/
    /***********************************************/
    case "frame":
      $txt = "<html>
      	<head><title>$img_name</title></head>
	<body>
		<h1>$img_name</h1>
		<img style='border-color: black; border-width: 1px;' src='$img_url' alt='$img_name'></img>
	</body>
     </html>";
     printf($txt);
     exit;
  }
}
  
/* renders a detailed image view */
function render_detailed($type = "normal", $row){ 
  global $ns, $sql, $IMAGES_DIRECTORY;
  $cobj = new comment;
  $frm = new form;
  /* extract the vars in $row */
  extract($row);

  /* create an object we need to convert datetimestamps */
  $gen = new convert;
  $sql = new DB;

  $img_url = get_img_url($img_image, $img_category);
  if (!strpos($img_url, "no-image.png")) $sql->db_Update("images", "img_views=img_views+1 WHERE img_id=$img_id");

  /* do some processing on the vars to make them suitable for printing */
  $img_datestamp = $gen->convert_date($img_datestamp, "short");

  /* get the rating of this image */
  $rate = new rater;
  $img_rating = $rate->getrating("images", $img_id);
  if ($img_rating[0]){
    $img_rating = strval($img_rating[1])."/".strval($img_rating[0]);
  } else {
    $img_rating = IG_193;
  }

  /* create the bar above the image */
  if ($type == 'browse' || $type == 'popup'){
    /* create a bar with prev - img_name - next */
    $myheader = '<table width="100%"><tr>';
    
    $sql->db_Select('images', 'min(img_id) AS prev_id', 'img_id > '.$img_id.' AND img_category='.$img_category);
    extract($sql->db_Fetch());
    if ($prev_id){
      $myheader .= '<td class="forumheader" style="text-align: left;"><a href="view.php?'.$prev_id.'.2"> &lt;&lt; '.IG_134.' </a></td>';
    } else {
      $myheader .= '<td class="forumheader" style="text-align: left;"> &lt;&lt; '.IG_134.' </td>';
    }

    $myheader .= '<td class="forumheader" style="text-align: center; width: 50%;"> '.$img_name.' </td>';

    $sql->db_Select('images', 'max(img_id) AS next_id', 'img_id < '.$img_id.' AND img_category='.$img_category);
    extract($sql->db_Fetch());
    if ($next_id){
      $myheader .= '<td class="forumheader" style="text-align: right;"><a href="view.php?'.$next_id.'.2"> '.IG_135.' &gt;&gt; </a></td>';
    } else {
      $myheader .= '<td class="forumheader" style="text-align: right;"> '.IG_135.' &gt;&gt; </td>';
    }

    $myheader .= '</tr></table>';
  } else {
    /* simple header */
    $myheader = '<table width="100%"><tr><td  class="forumheader" style="text-align: center;"> '.$img_name.' </td></tr></table>';
  }

  /* render the part of the page with the image */
  $mytxt = 
    $myheader .
    "<div style='text-align: center;margin-top: 4px;'><img src='$img_url' style='border:1px solid;' alt='$img_name' /></div>";

  /* create the section with the image information*/
  if ($type == "tech"){
    /* display technical information */
    $mytxt .=
      '<table>
        <tr><td class="forumheader">'.IG_189.'</td></tr>
	<tr><td class="forumheader3" colspan="4">'.IG_190.'</td></tr>
       </table>';
  } else {
    /* display normal information */
    $mytxt .= '<table width="100%"><tr>
      <td class="forumheader" colspan="2">'.IG_191.'</td>
      <td class="forumheader" style="width: 55%">'.IG_057.'</td>
      <td class="forumheader" style="white-space: nowrap; text-align: center;"> '.IG_192.' '.$img_rating;
    if (!$rate->checkrated("images", $img_id) && USER) $mytxt .= $rate->rateselect("", "images", $img_id);
    $mytxt .= '</td></tr>
    <tr>
      <td class="forumheader2">'.IG_194.'</td>
      <td class="forumheader3">'.$img_datestamp.'</TD>
      <td rowspan="3" colspan="2" class="forumheader3" style="vertical-align: top;">'.$img_description.'</td>
    </tr>
    <tr>
      <td class="forumheader2">'.IG_195.'</td>
      <td class="forumheader3">';
      
    if ($img_author_member) {
      $mytxt .= '<a href="/user.php?id.'.$img_author_member.'"><img style="border: 0px" src="/'.$IMAGES_DIRECTORY.'forum/profile.png" alt="'.IG_196.'" />'.$img_author.'<br />
      <img style="border: 0px" src="/'.$IMAGES_DIRECTORY.'forum/email.png" alt="'.IG_197.'" />'.$img_author_email.'<br />
      <img style="border: 0px" src="/'.$IMAGES_DIRECTORY.'forum/website.png" alt="'.IG_198.'" />'.$img_author_homepage.'</a>';
    } else {
      $mytxt .= '<img style="border: 0px" src="/'.$IMAGES_DIRECTORY.'forum/profile.png" alt="'.IG_196.'" />'.$img_author.'<br />';
      if ($img_author_email){
	$mytxt .= '<a href="mailto:'.$img_author_email.'"><img style="border: 0px" src="/'.$IMAGES_DIRECTORY.'forum/email.png" alt="'.IG_197.'" />'.$img_author_email.'</a><br />';
      }
      if ($img_author_homepage){
	$mytxt .= '<a href="'.$img_author_homepage.'"><img style="border: 0px" src="/'.$IMAGES_DIRECTORY.'forum/website.png" alt="'.IG_198.'" />'.$img_author_homepage.'</a>';
      }
    }
    
    $mytxt .= '</td>
      </tr>
      <tr>
	<td class="forumheader2">'.IG_199.'</td>
	<td class="forumheader3">'.$img_views.'</td>
      </tr></table>';
  }

  $mytxt .= "<div style='text-align: center'>";
  $mytxt .= $frm->form_open("post", "browse.php?$img_category");
  $mytxt .= $frm->form_button("submit", "submit", IG_019);
  $mytxt .= $frm->form_close()."</div>";
  
  /* comments yes or no */
  $sql->db_Select("images_category", "category_allow_comments", "category_id=".$img_category);
  list($category_allow_comments) = $sql->db_Fetch();
  if ($category_allow_comments){
    
    /* we need to capture the output of the comments rendering to display it later */
    ob_start();

    if ($pref['nested_comments']){
      $query = "comment_item_id='$img_id' AND comment_type='imgal' AND comment_pid='0' ORDER BY comment_datestamp";
    } else {
      $query = "comment_item_id='$img_id' AND comment_type='imgal' ORDER BY comment_datestamp";
    }
    
    unset($comments);

    if($comment_total = $sql->db_Select("comments", "*",  $query)){
      $width = 0;

      while($row = $sql->db_Fetch()){
	if($pref['nested_comments']){
	  $comments = $cobj->render_comment($row, "imgal", "comment", $img_id, $width, $img_name); 
	  $ns->tablerender("Comments", $text); 
	}else{
	  $comments .= $cobj->render_comment($row, "imgal", "comment", $img_id, $width, $img_name);
	}
      }

      if(!$pref['nested_comments']){
        $ns->tablerender(IG_201, $comments); 
      }
        if(ADMIN && getperms("B")){
        echo '<div style="text-align:right"><a href="'.e_ADMIN.'modcomment.php?imgal.'.$img_id.'">'.IG_200.'</a></div>';
      }
    } 

    $cobj->form_comment("comment", "imgal", $img_id, $img_name, false);

    $comments = ob_get_contents();
    ob_end_clean();
  }
  /* end of comments */

  global $HEADER;
  global $FOOTER;
  if ($type != 'popup') require_once(HEADERF);
  if (USER && is_authorized($img_category, "admin")){
    $ns->tablerender(IG_033, render_admin($img_category, $img_id));
  }
  $ns->tablerender(IG_133, $mytxt);
  if ($comments) echo $comments;
  if ($type != 'popup') require_once(FOOTERF);
}

function render_admin($category, $image){
  return '<a href="admin_browse.php?'.$category.'">'.IG_144.'</a> - 
          <a href="admin_image.php?edit.'.$category.'.'.$image.'">'.IG_202.'</a>';
}

?>
